package com.example.primarycourt.activity.ui.about;

import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.fragment.app.Fragment;

import com.example.primarycourt.R;
import com.example.primarycourt.app.AppConfig;

import java.util.Calendar;

public class AboutFragment extends Fragment implements View.OnClickListener {

    TextView app_version, copyright,trademarks,updateText;
    ImageView update;


    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View view = inflater.inflate(R.layout.fragment_about, container, false);

        app_version = view.findViewById(R.id.app_version);
        copyright = view.findViewById(R.id.copyright);
        trademarks = view.findViewById(R.id.trademarks);
        update = view.findViewById(R.id.update);
        updateText = view.findViewById(R.id.updateText);

        Calendar calendar = Calendar.getInstance();
        int year = calendar.get(Calendar.YEAR);

        app_version.setText(getResources().getString(R.string.verision_app) +": "+ AppConfig.App_Version);
        copyright.setText(AppConfig.CopyWrite+ year+ " "+ getResources().getString(R.string.judiciary));
        trademarks.setText(getResources().getString(R.string.trademark));

        update.setOnClickListener(this);
        updateText.setOnClickListener(this);
        return  view;
    }

    @Override
    public void onClick(View v) {

        Intent intent = new Intent();

        switch (v.getId()){

            case R.id.update:
            case R.id.updateText:
                intent.setAction(Intent.ACTION_VIEW);
                intent.addCategory(Intent.CATEGORY_BROWSABLE);
                intent.setData(Uri.parse(AppConfig.CheckUpdate));
                startActivity(intent);
                break;

        }

    }
}