package com.example.primarycourt.activity.ui.dashboard;

import android.app.ProgressDialog;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.fragment.app.Fragment;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;
import com.example.primarycourt.R;
import com.example.primarycourt.app.AppConfig;
import com.example.primarycourt.helper.SQLiteHandler;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.HashMap;

import static com.example.primarycourt.activity.ui.decided.DecidedFragment.courtID;
import static com.example.primarycourt.app.AppController.TAG;

/**
 * A simple {@link Fragment} subclass.
 * Use the {@link DashboardFragment#} factory method to
 * create an instance of this fragment.
 */
public class DashboardFragment extends Fragment {

    TextView PendingCases,FiledCasesDay,FiledCases,FiledCasesYear,DecidedCasesDay,DecidedCases,DecidedCasesYear,CourtName;
    TextView ProbatePending, DivorcePending, CivilPending, CriminalPending,WardPending;
    TextView ProbateDecided, DivorceDecided, CivilDecided, CriminalDecided,WardDecided;

    private ProgressDialog pDialog;
    private SQLiteHandler db;
    public static String uid;
    public static String
            COUNT_PENDING_CASE_PER,COUNT_FILED_CASE_DAY_PER,COUNT_FILED_CASE_PER,COUNT_FILED_CASE_YEAR_PER,COUNT_DECIDED_CASE_DAY_PER,
            COUNT_DECIDED_CASE_PER,COUNT_DECIDED_CASE_YEAR_PER,COUNT_DIVORCE_PENDING_CASE_PER,COUNT_DIVORCE_DECIDED_CASE_PER,COUNT_WARD_PENDING_CASE_PER,
            COUNT_WARD_DECIDED_CASE_PER, GET_COURT_NAME_PER,COUNT_PROBATE_PENDING_CASE_PER,COUNT_PROBATE_DECIDED_CASE_PER,COUNT_CIVIL_PENDING_CASE_PER,
            COUNT_CIVIL_DECIDED_CASE_PER,COUNT_CRIMINAL_PENDING_CASE_PER,COUNT_CRIMINAL_DECIDED_CASE_PER;

    RequestQueue requestQueue;

    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View view = inflater.inflate(R.layout.fragment_dashboard , container , false);
        requestQueue = Volley.newRequestQueue(getActivity());

        PendingCases = view.findViewById(R.id.Pending_Case_Count);
        FiledCasesDay = view.findViewById(R.id.filed_day_count);
        FiledCases = view.findViewById(R.id.filed_month_count);
        FiledCasesYear = view.findViewById(R.id.filed_year_count);
        DecidedCasesDay = view.findViewById(R.id.decided_day_count);
        DecidedCases = view.findViewById(R.id.decided_month_count);
        DecidedCasesYear = view.findViewById(R.id.decided_year_count);
        CourtName = view.findViewById(R.id.court_name);
        DivorcePending = view.findViewById(R.id.count_divorce_pending);
        DivorceDecided = view.findViewById(R.id.count_divorce_decided);
        ProbatePending = view.findViewById(R.id.count_probate_pending);
        ProbateDecided = view.findViewById(R.id.count_probate_decided);
        CivilPending = view.findViewById(R.id.count_civil_pending);
        CivilDecided = view.findViewById(R.id.count_civil_decided);
        CriminalPending = view.findViewById(R.id.count_criminal_pending);
        CriminalDecided = view.findViewById(R.id.count_criminal_decided);
        WardPending = view.findViewById(R.id.count_ward_pending);
        WardDecided = view.findViewById(R.id.count_ward_decided);

        pDialog = new ProgressDialog(getActivity());
        pDialog.setMessage("Loading...");
        pDialog.show();
        db = new SQLiteHandler(getActivity());
        HashMap<String, String> user = db.getUserDetails();
        courtID = user.get("courtID");
        uid = user.get("uid");


        //  LINKS FOR API TO DASHBOARD
        COUNT_PENDING_CASE_PER = AppConfig.IP_PATH + "magistrate_count_pending_case.php?courtID=" + courtID +" &userID=" + uid;
        COUNT_FILED_CASE_DAY_PER = AppConfig.IP_PATH + "magistrate_count_filed_case_day.php?courtID=" + courtID +" &userID=" + uid;
        COUNT_FILED_CASE_PER = AppConfig.IP_PATH + "magistrate_count_filed_case.php?courtID=" + courtID + " &userID=" + uid;
        COUNT_FILED_CASE_YEAR_PER = AppConfig.IP_PATH +"magistrate_count_filed_case_year.php?courtID=" + courtID + " &userID=" + uid;
        COUNT_DECIDED_CASE_DAY_PER = AppConfig.IP_PATH + "magistrate_count_decided_case_day.php?courtID=" + courtID + " &userID=" + uid;
        COUNT_DECIDED_CASE_PER = AppConfig.IP_PATH + "magistrate_count_decided_case.php?courtID=" + courtID + " &userID=" + uid;
        COUNT_DECIDED_CASE_YEAR_PER = AppConfig.IP_PATH + "magistrate_count_decided_case_year.php?courtID=" + courtID + " &userID=" + uid;
        GET_COURT_NAME_PER = AppConfig.IP_PATH+"get_court_name.php?courtID=" + courtID;
        COUNT_DIVORCE_PENDING_CASE_PER = AppConfig.IP_PATH+"magistrate_count_divorce_pending_case.php?courtID="+courtID + " &userID=" + uid;
        COUNT_DIVORCE_DECIDED_CASE_PER = AppConfig.IP_PATH+"magistrate_count_divorce_decided_case.php?courtID="+courtID + " &userID=" + uid;
        COUNT_PROBATE_PENDING_CASE_PER = AppConfig.IP_PATH+"magistrate_count_probate_pending_case.php?courtID="+courtID + " &userID=" + uid;
        COUNT_PROBATE_DECIDED_CASE_PER = AppConfig.IP_PATH+"magistrate_count_probate_decided_case.php?courtID="+courtID + " &userID=" + uid;
        COUNT_CIVIL_PENDING_CASE_PER = AppConfig.IP_PATH+"magistrate_count_civil_pending_case.php?courtID="+courtID + " &userID=" + uid;
        COUNT_CIVIL_DECIDED_CASE_PER = AppConfig.IP_PATH+"magistrate_count_civil_decided_case.php?courtID="+courtID + " &userID=" + uid;
        COUNT_CRIMINAL_PENDING_CASE_PER  = AppConfig.IP_PATH+"magistrate_count_criminal_pending_case.php?courtID="+courtID + " &userID=" + uid;
        COUNT_CRIMINAL_DECIDED_CASE_PER  = AppConfig.IP_PATH+"magistrate_count_criminal_decided_case.php?courtID="+courtID + " &userID=" + uid;
        COUNT_WARD_PENDING_CASE_PER  = AppConfig.IP_PATH+"magistrate_count_ward_pending_case.php?courtID="+courtID + " &userID=" + uid;
        COUNT_WARD_DECIDED_CASE_PER  = AppConfig.IP_PATH+"magistrate_count_ward_decided_case.php?courtID="+courtID + " &userID=" + uid;


        getTotalPending();

        getTotalFiledDay();
        getTotalFiled();
        getTotalFiledYear();

        getTotalDecidedDay();
        getTotalDecided();
        getTotalDecidedYear();

        getTotalDivorcePending();
        getTotalDivorceDecided();
        getTotalProbatePending();
        getTotalProbateDecided();
        getTotalCivilPending();
        getTotalCivilDecided();
        getTotalCriminalPending();
        getTotalCriminalDecided();
        getTotalWardPending();
        getTotalWardDecided();
        getCourtName();


        return view;
    }

    private void getTotalPending(){
        StringRequest count_pending_case = new StringRequest(Request.Method.GET,COUNT_PENDING_CASE_PER,
                new Response.Listener<String>() {

                    @Override
                    public void onResponse(String response) {
                        Log.d(TAG, "Login Response: " + response);
                        hideDialog();

                        try {
                            JSONObject obj = new JSONObject(response);
                            String C_Pending = obj.getString("Pending");
                            PendingCases.setText(C_Pending);
                        }
                        catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }, new Response.ErrorListener() {
            @Override
            // Handles errors that occur due to Volley
            public void onErrorResponse(VolleyError error) {
                Log.e("Volley", error.getMessage());
                hideDialog();
            }
        });
        requestQueue.add(count_pending_case);
    }
    private void getTotalFiled(){
        StringRequest count_filed_case = new StringRequest(Request.Method.GET,COUNT_FILED_CASE_PER,
                new Response.Listener<String>() {

                    @Override
                    public void onResponse(String response) {
                        Log.d(TAG, "Login Response: " + response);
                        hideDialog();

                        try {
                            JSONObject obj = new JSONObject(response);
                            String C_Filed = obj.getString("Filed");
                            FiledCases.setText(C_Filed);
                        }
                        catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }, new Response.ErrorListener() {
            @Override
            // Handles errors that occur due to Volley
            public void onErrorResponse(VolleyError error) {
                Log.e("Volley", error.getMessage());
                hideDialog();
            }
        });
        requestQueue.add(count_filed_case);
    }
    private void getTotalFiledYear(){
        StringRequest count_filed_case_year = new StringRequest(Request.Method.GET,COUNT_FILED_CASE_YEAR_PER,
                new Response.Listener<String>() {

                    @Override
                    public void onResponse(String response) {
                        Log.d(TAG, "Login Response: " + response);
                        hideDialog();

                        try {
                            JSONObject obj = new JSONObject(response);
                            String Year_Filed = obj.getString("Year_Filed");
                            FiledCasesYear.setText(Year_Filed);
                        }
                        catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }, new Response.ErrorListener() {
            @Override
            // Handles errors that occur due to Volley
            public void onErrorResponse(VolleyError error) {
                Log.e("Volley", error.getMessage());
                hideDialog();
            }
        });
        requestQueue.add(count_filed_case_year);
    }
    private void getTotalFiledDay(){
        StringRequest count_filed_case_day = new StringRequest(Request.Method.GET,COUNT_FILED_CASE_DAY_PER,
                new Response.Listener<String>() {

                    @Override
                    public void onResponse(String response) {
                        Log.d(TAG, "Login Response: " + response);
                        hideDialog();

                        try {
                            JSONObject obj = new JSONObject(response);
                            String Day_Filed = obj.getString("Day_Filed");
                            FiledCasesDay.setText(Day_Filed);
                        }
                        catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }, new Response.ErrorListener() {
            @Override
            // Handles errors that occur due to Volley
            public void onErrorResponse(VolleyError error) {
                Log.e("Volley", error.getMessage());
                hideDialog();
            }
        });
        requestQueue.add(count_filed_case_day);
    }
    private void getTotalDecidedDay(){
        StringRequest count_decided_case_day = new StringRequest(Request.Method.GET,COUNT_DECIDED_CASE_DAY_PER,
                new Response.Listener<String>() {

                    @Override
                    public void onResponse(String response) {
                        Log.d(TAG, "Login Response: " + response);
                        hideDialog();

                        try {
                            JSONObject obj = new JSONObject(response);
                            String C_Decided = obj.getString("Day_Decided");
                            DecidedCasesDay.setText(C_Decided);
                        }
                        catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }, new Response.ErrorListener() {
            @Override
            // Handles errors that occur due to Volley
            public void onErrorResponse(VolleyError error) {
                Log.e("Volley", error.getMessage());
                hideDialog();
            }
        });
        requestQueue.add(count_decided_case_day);
    }
    private void getTotalDecided(){
        StringRequest count_decided_case = new StringRequest(Request.Method.GET,COUNT_DECIDED_CASE_PER,
                new Response.Listener<String>() {

                    @Override
                    public void onResponse(String response) {
                        Log.d(TAG, "Login Response: " + response);
                        hideDialog();

                        try {
                            JSONObject obj = new JSONObject(response);
                            String C_Decided = obj.getString("Decided");
                            DecidedCases.setText(C_Decided);
                        }
                        catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }, new Response.ErrorListener() {
            @Override
            // Handles errors that occur due to Volley
            public void onErrorResponse(VolleyError error) {
                Log.e("Volley", error.getMessage());
                hideDialog();
            }
        });
        requestQueue.add(count_decided_case);
    }
    private void getTotalDecidedYear(){
        StringRequest count_decided_case_year = new StringRequest(Request.Method.GET,COUNT_DECIDED_CASE_YEAR_PER,
                new Response.Listener<String>() {

                    @Override
                    public void onResponse(String response) {
                        Log.d(TAG, "Login Response: " + response);
                        hideDialog();

                        try {
                            JSONObject obj = new JSONObject(response);
                            String C_Decided = obj.getString("Year_Decided");
                            DecidedCasesYear.setText(C_Decided);
                        }
                        catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }, new Response.ErrorListener() {
            @Override
            // Handles errors that occur due to Volley
            public void onErrorResponse(VolleyError error) {
                Log.e("Volley", error.getMessage());
                hideDialog();
            }
        });
        requestQueue.add(count_decided_case_year);
    }
    private void getTotalDivorcePending(){
        StringRequest count_divorce_pending_case = new StringRequest(Request.Method.GET,COUNT_DIVORCE_PENDING_CASE_PER,
                new Response.Listener<String>() {

                    @Override
                    public void onResponse(String response) {
                        Log.d(TAG, "Login Response: " + response);
                        hideDialog();

                        try {
                            JSONObject obj = new JSONObject(response);
                            String Divorce_Pending = obj.getString("Divorce");
                            DivorcePending.setText(Divorce_Pending);
                        }
                        catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }, new Response.ErrorListener() {
            @Override
            // Handles errors that occur due to Volley
            public void onErrorResponse(VolleyError error) {
                Log.e("Volley", error.getMessage());
                hideDialog();
            }
        });
        requestQueue.add(count_divorce_pending_case);
    }
    private void getTotalDivorceDecided(){
        StringRequest count_divorce_decided_case = new StringRequest(Request.Method.GET,COUNT_DIVORCE_DECIDED_CASE_PER,
                new Response.Listener<String>() {

                    @Override
                    public void onResponse(String response) {
                        Log.d(TAG, "Login Response: " + response);
                        hideDialog();

                        try {
                            JSONObject obj = new JSONObject(response);
                            String Divorce_Decided = obj.getString("Divorce");
                            DivorceDecided.setText(Divorce_Decided);
                        }
                        catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }, new Response.ErrorListener() {
            @Override
            // Handles errors that occur due to Volley
            public void onErrorResponse(VolleyError error) {
                Log.e("Volley", error.getMessage());
                hideDialog();
            }
        });
        requestQueue.add(count_divorce_decided_case);
    }
    private void getTotalProbatePending(){
        StringRequest count_probate_pending_case = new StringRequest(Request.Method.GET,COUNT_PROBATE_PENDING_CASE_PER,
                new Response.Listener<String>() {

                    @Override
                    public void onResponse(String response) {
                        Log.d(TAG, "Login Response: " + response);
                        hideDialog();

                        try {
                            JSONObject obj = new JSONObject(response);
                            String Probate_Pending = obj.getString("Probate");
                            ProbatePending.setText(Probate_Pending);
                        }
                        catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }, new Response.ErrorListener() {
            @Override
            // Handles errors that occur due to Volley
            public void onErrorResponse(VolleyError error) {
                Log.e("Volley", error.getMessage());
                hideDialog();
            }
        });
        requestQueue.add(count_probate_pending_case);
    }
    private void getTotalProbateDecided(){
        StringRequest count_probate_decided_case = new StringRequest(Request.Method.GET,COUNT_PROBATE_DECIDED_CASE_PER,
                new Response.Listener<String>() {

                    @Override
                    public void onResponse(String response) {
                        Log.d(TAG, "Login Response: " + response);
                        hideDialog();

                        try {
                            JSONObject obj = new JSONObject(response);
                            String Probate_Decided = obj.getString("Probate");
                            ProbateDecided.setText(Probate_Decided);
                        }
                        catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }, new Response.ErrorListener() {
            @Override
            // Handles errors that occur due to Volley
            public void onErrorResponse(VolleyError error) {
                Log.e("Volley", error.getMessage());
                hideDialog();
            }
        });
        requestQueue.add(count_probate_decided_case);
    }
    private void getTotalCivilPending(){
        StringRequest count_civil_pending_case = new StringRequest(Request.Method.GET,COUNT_CIVIL_PENDING_CASE_PER,
                new Response.Listener<String>() {

                    @Override
                    public void onResponse(String response) {
                        Log.d(TAG, "Login Response: " + response);
                        hideDialog();

                        try {
                            JSONObject obj = new JSONObject(response);
                            String Civil_Pending = obj.getString("Civil");
                            CivilPending.setText(Civil_Pending);
                        }
                        catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }, new Response.ErrorListener() {
            @Override
            // Handles errors that occur due to Volley
            public void onErrorResponse(VolleyError error) {
                Log.e("Volley", error.getMessage());
                hideDialog();
            }
        });
        requestQueue.add(count_civil_pending_case);
    }
    private void getTotalCivilDecided(){
        StringRequest count_civil_decided_case = new StringRequest(Request.Method.GET,COUNT_CIVIL_DECIDED_CASE_PER,
                new Response.Listener<String>() {

                    @Override
                    public void onResponse(String response) {
                        Log.d(TAG, "Login Response: " + response);
                        hideDialog();

                        try {
                            JSONObject obj = new JSONObject(response);
                            String Civil_Decided = obj.getString("Civil");
                            CivilDecided.setText(Civil_Decided);
                        }
                        catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }, new Response.ErrorListener() {
            @Override
            // Handles errors that occur due to Volley
            public void onErrorResponse(VolleyError error) {
                Log.e("Volley", error.getMessage());
                hideDialog();
            }
        });
        requestQueue.add(count_civil_decided_case);
    }
    private void getTotalWardPending(){
        StringRequest count_ward_pending_case = new StringRequest(Request.Method.GET,COUNT_WARD_PENDING_CASE_PER,
                new Response.Listener<String>() {

                    @Override
                    public void onResponse(String response) {
                        Log.d(TAG, "Login Response: " + response);
                        hideDialog();

                        try {
                            JSONObject obj = new JSONObject(response);
                            String Ward_Pending = obj.getString("Ward");
                            WardPending.setText(Ward_Pending);
                        }
                        catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }, new Response.ErrorListener() {
            @Override
            // Handles errors that occur due to Volley
            public void onErrorResponse(VolleyError error) {
                Log.e("Volley", error.getMessage());
                hideDialog();
            }
        });
        requestQueue.add(count_ward_pending_case);
    }
    private void getTotalWardDecided(){
        StringRequest count_ward_decided_case = new StringRequest(Request.Method.GET,COUNT_WARD_DECIDED_CASE_PER,
                new Response.Listener<String>() {

                    @Override
                    public void onResponse(String response) {
                        Log.d(TAG, "Login Response: " + response);
                        hideDialog();

                        try {
                            JSONObject obj = new JSONObject(response);
                            String Ward_Decided = obj.getString("Ward");
                            WardDecided.setText(Ward_Decided);
                        }
                        catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }, new Response.ErrorListener() {
            @Override
            // Handles errors that occur due to Volley
            public void onErrorResponse(VolleyError error) {
                Log.e("Volley", error.getMessage());
                hideDialog();
            }
        });
        requestQueue.add(count_ward_decided_case);
    }
    private void getTotalCriminalPending(){
        StringRequest count_criminal_pending_case = new StringRequest(Request.Method.GET,COUNT_CRIMINAL_PENDING_CASE_PER,
                new Response.Listener<String>() {

                    @Override
                    public void onResponse(String response) {
                        Log.d(TAG, "Login Response: " + response);
                        hideDialog();

                        try {
                            JSONObject obj = new JSONObject(response);
                            String Criminal_Pending = obj.getString("Criminal");
                            CriminalPending.setText(Criminal_Pending);
                        }
                        catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }, new Response.ErrorListener() {
            @Override
            // Handles errors that occur due to Volley
            public void onErrorResponse(VolleyError error) {
                Log.e("Volley", error.getMessage());
                hideDialog();
            }
        });
        requestQueue.add(count_criminal_pending_case);
    }
    private void getTotalCriminalDecided(){
        StringRequest count_criminal_decided_case = new StringRequest(Request.Method.GET,COUNT_CRIMINAL_DECIDED_CASE_PER,
                new Response.Listener<String>() {

                    @Override
                    public void onResponse(String response) {
                        Log.d(TAG, "Login Response: " + response);
                        hideDialog();

                        try {
                            JSONObject obj = new JSONObject(response);
                            String Criminal_Decided = obj.getString("Criminal");
                            CriminalDecided.setText(Criminal_Decided);
                        }
                        catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }, new Response.ErrorListener() {
            @Override
            // Handles errors that occur due to Volley
            public void onErrorResponse(VolleyError error) {
                Log.e("Volley", error.getMessage());
                hideDialog();
            }
        });
        requestQueue.add(count_criminal_decided_case);
    }
    private void getCourtName(){
        StringRequest user_court_name = new StringRequest(Request.Method.GET,GET_COURT_NAME_PER,
                new Response.Listener<String>() {

                    @Override
                    public void onResponse(String response) {
                        Log.d(TAG, "Login Response: " + response);
                        hideDialog();

                        try {
                            JSONObject obj = new JSONObject(response);
                            String Court_Name = obj.getString("court_name");
                            CourtName.setText(Court_Name);
                        }
                        catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }, new Response.ErrorListener() {
            @Override
            // Handles errors that occur due to Volley
            public void onErrorResponse(VolleyError error) {
                Log.e("Volley", error.getMessage());
                hideDialog();
            }
        });
        requestQueue.add(user_court_name);
    }
    private void hideDialog() {
        if (pDialog != null) {
            pDialog.dismiss();
            pDialog = null;
        }
    }
}