package com.example.primarycourt.activity.ui.decided;

import android.app.ProgressDialog;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;

import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;

import com.example.primarycourt.R;
import com.example.primarycourt.helper.PendingCase;
import com.example.primarycourt.helper.SQLiteHandler;

import java.util.HashMap;
import java.util.Map;


public class CasedetailsFragment extends Fragment {

    private static final String TAG = CasedetailsFragment.class.getSimpleName();

    TextView courtID;
    TextView Case_Type;
    TextView Case_Number;
    TextView Case_Year;
    TextView Appellant;
    TextView Defendant;
    TextView Claim;
    TextView Filing_Date;
    TextView Decision_Date;
    TextView Case_Decision;
    TextView Mode_Determination;
    TextView Case_Outcome;
    TextView Case_Magistrate;
    Button btn_editCaseInfo;
    public static String user_courtID;
    public static PendingCase pendingCase;
    SQLiteHandler db;
    ProgressDialog pDialog;

    public View onCreateView(LayoutInflater inflater , ViewGroup container ,
                             Bundle savedInstanceState) {

        // Inflate the layout for this fragment
        View view = inflater.inflate(R.layout.fragment_casedetails , container , false);

        // SQLite database handler
        db = new SQLiteHandler(getActivity());

        courtID = view.findViewById(R.id.courtID);
        Case_Type = view.findViewById(R.id.case_type);
        Case_Number = view.findViewById(R.id.case_number);
        Case_Year = view.findViewById(R.id.case_year);
        Appellant = view.findViewById(R.id.view_appellant);
        Defendant = view.findViewById(R.id.view_defendant);
        Claim = view.findViewById(R.id.view_claim);
        Filing_Date = view.findViewById(R.id.view_filing_date);
        Case_Magistrate = view.findViewById(R.id.view_magistrate);
        Decision_Date = view.findViewById(R.id.view_decision_date);
        Mode_Determination = view.findViewById(R.id.view_mode_determination);
        Case_Outcome = view.findViewById(R.id.view_outcome);
        Case_Decision = view.findViewById(R.id.view_case_remarks);
        btn_editCaseInfo = view.findViewById(R.id.btn_editCaseInfo);


        final String CaseType = getArguments().getString("case_type");
        final String CaseNumber = getArguments().getString("case_number");
        final String CaseYear = getArguments().getString("case_year");
        String CaseAppellant = getArguments().getString("case_appellant");
        String CaseDefendant = getArguments().getString("case_defendant");
        String CaseClaim = getArguments().getString("case_claim");
        String FilingDate = getArguments().getString("filing_date");
        String CaseMagistrate = getArguments().getString("assigned_to");
        final String DecisionDate = getArguments().getString("decided_date");
        final String ModeDetermination = getArguments().getString("mode_determination");
        final String CaseOutcome = getArguments().getString("case_outcome");
        final  String CaseDecision = getArguments().getString("decision_remarks");

        CasedetailsFragment.pendingCase = new PendingCase();
        Map<String, String> params = new HashMap<>();
        HashMap<String, String> user = db.getUserDetails();
        user_courtID = user.get("courtID");
        courtID.setText(user.get("courtID"));

        Case_Type.setText(CaseType);
        Case_Number.setText(CaseNumber);
        Case_Year.setText(CaseYear);
        Appellant.setText(CaseAppellant);
        Defendant.setText(CaseDefendant);
        Claim.setText(CaseClaim);
        Filing_Date.setText(FilingDate);
        Case_Magistrate.setText(CaseMagistrate);
        Decision_Date.setText(DecisionDate);
        Mode_Determination.setText(ModeDetermination);
        Case_Outcome.setText(CaseOutcome);
        Case_Decision.setText(CaseDecision);

        // Progress dialog
        pDialog = new ProgressDialog(getActivity());
        pDialog.setCancelable(false);

        // SQLite database handler
        db = new SQLiteHandler(getActivity());
        btn_editCaseInfo.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                Bundle bundle = new Bundle();
                bundle.putString("CaseNumber",CaseNumber);
                bundle.putString("CaseYear",CaseYear);
                bundle.putString("CaseType", CaseType);
                bundle.putString("DecisionDate" , DecisionDate);
                bundle.putString("ModeDetermination" , ModeDetermination);
                bundle.putString("CaseOutcome" , CaseOutcome);
                bundle.putString("CaseDecision" , CaseDecision);

                EditDecisionFragment fragment = new EditDecisionFragment();
                FragmentManager fragmentManager = getFragmentManager();
                FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();
                fragment.setArguments(bundle);
                fragmentTransaction.replace(R.id.nav_host_fragment, fragment, fragment.getTag());
                fragmentTransaction.addToBackStack(null);
                fragmentTransaction.commit();
            }
        });
        return view;
    }

}
