package com.example.primarycourt.activity.ui.decided;

import android.app.ProgressDialog;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;

import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;

import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.VolleyLog;
import com.android.volley.toolbox.JsonArrayRequest;
import com.example.primarycourt.R;
import com.example.primarycourt.app.AppConfig;
import com.example.primarycourt.app.AppController;
import com.example.primarycourt.helper.CustomListAdapter;
import com.example.primarycourt.helper.PendingCase;
import com.example.primarycourt.helper.SQLiteHandler;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;

import static com.example.primarycourt.app.AppController.TAG;

public class DecidedFragment extends Fragment {

    TextView empty;
    EditText inputSearch;
    public static String courtID;
    private ProgressDialog pDialog;
    private ArrayList<PendingCase> caseList = new ArrayList<PendingCase>();
    private ListView listView;
    public static int designation_id;
    public static String assigned_to;
    private CustomListAdapter adapter;
    private SQLiteHandler db;
    public static String URL_DECIDED_CASE;


    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment


        View view = inflater.inflate(R.layout.fragment_decided , container , false);


        listView = view.findViewById(R.id.list_decided);
        empty = view.findViewById(android.R.id.empty);
        inputSearch = view.findViewById(R.id.inputSearch);
        adapter = new CustomListAdapter(getActivity() , caseList);
        listView.setEmptyView(empty);
        listView.setAdapter(adapter);


        pDialog = new ProgressDialog(getActivity());
        // Showing progress dialog before making http request
        pDialog.setMessage("Loading...");
        pDialog.show();

        db = new SQLiteHandler(getActivity());
        HashMap<String, String> user = db.getUserDetails();

        courtID = user.get("courtID");
        assigned_to = user.get("uid");
        designation_id = Integer.parseInt(user.get("designation_id"));

        //===============================================================================================
        //=======================    Vieww to  magistrate Only           =================================
        //===============================================================================================

        if(designation_id == 10){

            URL_DECIDED_CASE = AppConfig.IP_PATH + "magistrate_get_decided_case.php?courtID=" + courtID + "&assigned_to=" + assigned_to;

        // Creating volley request obj
        JsonArrayRequest movieReq = new JsonArrayRequest(URL_DECIDED_CASE ,
                new Response.Listener<JSONArray>() {
                    @Override
                    public void onResponse(JSONArray response) {
                        Log.d(TAG , response.toString());
                        hidePDialog();

                        // Parsing json


                        for (int i = 0; i < response.length(); i++) {
                            try {

                                JSONObject obj = response.getJSONObject(i);
                                PendingCase pending_list = new PendingCase();
                                pending_list.setCaseType(obj.getString("case_type"));
                                pending_list.setThumbnailUrl(obj.getString("img"));
                                pending_list.setCaseNumber((obj.getString("case_number")));
                                pending_list.setCaseYear(obj.getString("case_year"));
                                pending_list.setAppellant((obj.getString("case_appellant")));
                                pending_list.setDefendant(obj.getString("case_defendant"));
                                pending_list.setClaim(obj.getString("case_claim"));
                                pending_list.setFilingDate(obj.getString("filing_date"));
                                pending_list.setMagistrate(obj.getString("assigned_to"));
                                pending_list.setDecidedDate((obj.getString("decided_date")));
                                pending_list.setDeterminationMode(obj.getString("mode_determination"));
                                pending_list.setCaseOutcome(obj.getString("case_outcome"));
                                pending_list.setCaseRemarks(obj.getString("decision_remarks"));

                                caseList.add(pending_list);


                                listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {

                                    public void onItemClick(AdapterView<?> l , View view , int position , long id) {
                                        //Put the value
                                        String CaseType = ((TextView) view.findViewById(R.id.case_type)).getText().toString();
                                        String CaseNumber = ((TextView) view.findViewById(R.id.case_number)).getText().toString();
                                        String CaseYear = ((TextView) view.findViewById(R.id.case_year)).getText().toString();
                                        String CaseAppellant = ((TextView) view.findViewById(R.id.appellant)).getText().toString();
                                        String CaseDefendant = ((TextView) view.findViewById(R.id.defendant)).getText().toString();
                                        String CaseClaim = ((TextView) view.findViewById(R.id.case_claim)).getText().toString();
                                        String CaseFilingDate = ((TextView) view.findViewById(R.id.case_filing_date)).getText().toString();
                                        String CaseAssignment = ((TextView) view.findViewById(R.id.magistrate)).getText().toString();
                                        String DecisionDate = ((TextView) view.findViewById(R.id.case_decided_date)).getText().toString();
                                        String DeterminationMode = ((TextView) view.findViewById(R.id.case_mode_determination)).getText().toString();
                                        String CaseOutCome = ((TextView) view.findViewById(R.id.case_outcome)).getText().toString();
                                        String CaseRemarks = ((TextView) view.findViewById(R.id.case_remarks)).getText().toString();


                                        Bundle bundle = new Bundle();
                                        bundle.putString("case_type" , CaseType);
                                        bundle.putString("case_number" , CaseNumber);
                                        bundle.putString("case_year" , CaseYear);
                                        bundle.putString("case_appellant" , CaseAppellant);
                                        bundle.putString("case_defendant" , CaseDefendant);
                                        bundle.putString("case_claim" , CaseClaim);
                                        bundle.putString("filing_date" , CaseFilingDate);
                                        bundle.putString("assigned_to" , CaseAssignment);
                                        bundle.putString("decided_date" , DecisionDate);
                                        bundle.putString("mode_determination" , DeterminationMode);
                                        bundle.putString("case_outcome" , CaseOutCome);
                                        bundle.putString("decision_remarks" , CaseRemarks);

                                        CasedetailsFragment fragment = new CasedetailsFragment();
                                        FragmentManager fragmentManager = getFragmentManager();
                                        FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();
                                        fragment.setArguments(bundle);

                                        fragmentTransaction.replace(R.id.nav_host_fragment , fragment , fragment.getTag());
                                        fragmentTransaction.commit();

                                    }
                                });

                            } catch (JSONException e) {
                                e.printStackTrace();
                            }

                        }


                        // notifying list adapter about data changes
                        // so that it renders the list view with updated data

                        adapter.notifyDataSetChanged();


                    }
                } , new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                VolleyLog.d(TAG , "Error: " + error.getMessage());
                hidePDialog();

            }
        });

        // Adding request to request queue
        AppController.getInstance().addToRequestQueue(movieReq);

    }


  //===============================================================================================
  //======================= VIew to  magistrate Incharge and RMAs =================================
  //===============================================================================================

    else{


            URL_DECIDED_CASE = AppConfig.IP_PATH + "get_decided_case.php?courtID=" + courtID;
            // Creating volley request obj
            JsonArrayRequest movieReq = new JsonArrayRequest(URL_DECIDED_CASE ,
                    new Response.Listener<JSONArray>() {
                        @Override
                        public void onResponse(JSONArray response) {
                            Log.d(TAG , response.toString());
                            hidePDialog();

                            // Parsing json


                            for (int i = 0; i < response.length(); i++) {
                                try {

                                    JSONObject obj = response.getJSONObject(i);
                                    PendingCase pending_list = new PendingCase();
                                    pending_list.setCaseType(obj.getString("case_type"));
                                    pending_list.setThumbnailUrl(obj.getString("img"));
                                    pending_list.setCaseNumber((obj.getString("case_number")));
                                    pending_list.setCaseYear(obj.getString("case_year"));
                                    pending_list.setAppellant((obj.getString("case_appellant")));
                                    pending_list.setDefendant(obj.getString("case_defendant"));
                                    pending_list.setClaim(obj.getString("case_claim"));
                                    pending_list.setFilingDate(obj.getString("filing_date"));
                                    pending_list.setMagistrate(obj.getString("assigned_to"));
                                    pending_list.setDecidedDate((obj.getString("decided_date")));
                                    pending_list.setDeterminationMode(obj.getString("mode_determination"));
                                    pending_list.setCaseOutcome(obj.getString("case_outcome"));
                                    pending_list.setCaseRemarks(obj.getString("decision_remarks"));

                                    caseList.add(pending_list);


                                    listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {

                                        public void onItemClick(AdapterView<?> l , View view , int position , long id) {
                                            //Put the value
                                            String CaseType = ((TextView) view.findViewById(R.id.case_type)).getText().toString();
                                            String CaseNumber = ((TextView) view.findViewById(R.id.case_number)).getText().toString();
                                            String CaseYear = ((TextView) view.findViewById(R.id.case_year)).getText().toString();
                                            String CaseAppellant = ((TextView) view.findViewById(R.id.appellant)).getText().toString();
                                            String CaseDefendant = ((TextView) view.findViewById(R.id.defendant)).getText().toString();
                                            String CaseClaim = ((TextView) view.findViewById(R.id.case_claim)).getText().toString();
                                            String CaseFilingDate = ((TextView) view.findViewById(R.id.case_filing_date)).getText().toString();
                                            String CaseAssignment = ((TextView) view.findViewById(R.id.magistrate)).getText().toString();
                                            String DecisionDate = ((TextView) view.findViewById(R.id.case_decided_date)).getText().toString();
                                            String DeterminationMode = ((TextView) view.findViewById(R.id.case_mode_determination)).getText().toString();
                                            String CaseOutCome = ((TextView) view.findViewById(R.id.case_outcome)).getText().toString();
                                            String CaseRemarks = ((TextView) view.findViewById(R.id.case_remarks)).getText().toString();


                                            Bundle bundle = new Bundle();
                                            bundle.putString("case_type" , CaseType);
                                            bundle.putString("case_number" , CaseNumber);
                                            bundle.putString("case_year" , CaseYear);
                                            bundle.putString("case_appellant" , CaseAppellant);
                                            bundle.putString("case_defendant" , CaseDefendant);
                                            bundle.putString("case_claim" , CaseClaim);
                                            bundle.putString("filing_date" , CaseFilingDate);
                                            bundle.putString("assigned_to" , CaseAssignment);
                                            bundle.putString("decided_date" , DecisionDate);
                                            bundle.putString("mode_determination" , DeterminationMode);
                                            bundle.putString("case_outcome" , CaseOutCome);
                                            bundle.putString("decision_remarks" , CaseRemarks);

                                            CasedetailsFragment fragment = new CasedetailsFragment();
                                            FragmentManager fragmentManager = getFragmentManager();
                                            FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();
                                            fragment.setArguments(bundle);

                                            fragmentTransaction.replace(R.id.nav_host_fragment , fragment , fragment.getTag());
                                            fragmentTransaction.commit();

                                        }
                                    });

                                } catch (JSONException e) {
                                    e.printStackTrace();
                                }

                            }


                            // notifying list adapter about data changes
                            // so that it renders the list view with updated data

                            adapter.notifyDataSetChanged();


                        }
                    } , new Response.ErrorListener() {
                @Override
                public void onErrorResponse(VolleyError error) {
                    VolleyLog.d(TAG , "Error: " + error.getMessage());
                    hidePDialog();

                }
            });

            // Adding request to request queue
            AppController.getInstance().addToRequestQueue(movieReq);


        }





        /**
         * Enabling Search Filter
         * */
        inputSearch.addTextChangedListener(new TextWatcher() {

            @Override
            public void beforeTextChanged(CharSequence arg0, int arg1, int arg2, int arg3) {
                // TODO Auto-generated method stub
            }

            @Override
            public void onTextChanged(CharSequence cs, int arg1, int arg2, int arg3) {
                // When user changed the Text
                DecidedFragment.this.adapter.getFilter().filter(cs);

            }


            @Override
            public void afterTextChanged(Editable cs) {
                // TODO Auto-generated method stub
                inputSearch.removeTextChangedListener(this);
                inputSearch.addTextChangedListener(this);

                Log.e("Value","After");



            }
        });


        return view;
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        hidePDialog();
    }

    private void hidePDialog() {
        if (pDialog != null) {
            pDialog.dismiss();
            pDialog = null;
        }
    }

}