package com.example.primarycourt.activity.ui.decided;

import android.app.DatePickerDialog;
import android.app.ProgressDialog;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;

import com.android.volley.Request;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonArrayRequest;
import com.android.volley.toolbox.StringRequest;
import com.example.primarycourt.R;
import com.example.primarycourt.activity.ui.update.DecisionFragment;
import com.example.primarycourt.app.AppConfig;
import com.example.primarycourt.app.AppController;
import com.example.primarycourt.helper.ModelMode;
import com.example.primarycourt.helper.ModelOutcome;
import com.example.primarycourt.helper.PendingCase;
import com.example.primarycourt.helper.SQLiteHandler;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.util.TimeZone;

import static android.R.layout.simple_spinner_item;

public class EditDecisionFragment extends Fragment {
    final Calendar calendar= Calendar.getInstance(TimeZone.getTimeZone("UTC"));
    private static final String TAG = EditDecisionFragment.class.getSimpleName();

    public static String courtID;
    ProgressDialog pDialog;
    EditText EditDecisionDate,EditDecision;
    TextView CaseTitle;
    Spinner EditModeDetermination,EditCaseOutcome;
    Button btnEditCaseDecision;
    DatePickerDialog.OnDateSetListener DecisionDate;

    DateFormat input = new SimpleDateFormat("yyyy-MM-dd");
    DateFormat output = new SimpleDateFormat("dd-MM-yyyy");
    SQLiteHandler db;

    private ArrayList<ModelOutcome> OutComeModelArrayList = new ArrayList<ModelOutcome>();
    private ArrayList<ModelMode> ModeModelArrayList = new ArrayList<ModelMode>();
    private ArrayList<String> caseoutcome = new ArrayList<String>();
    private ArrayList<String> casemode = new ArrayList<String>();

    public View onCreateView(LayoutInflater inflater , ViewGroup container ,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment

        View view = inflater.inflate(R.layout.fragment_edit_decision , container , false);

        db = new SQLiteHandler(getActivity());
        pDialog = new ProgressDialog(getActivity());
        pDialog.setCancelable(false);

        CaseTitle = view.findViewById(R.id.CaseTitle);
        EditDecisionDate = view.findViewById(R.id.EditDecisionDate);
        EditModeDetermination = view.findViewById(R.id.EditModeDetermination);
        EditCaseOutcome = view.findViewById(R.id.EditCaseOutcome);
        EditDecision = view.findViewById(R.id.EditDecision);
        btnEditCaseDecision = view.findViewById(R.id.btnEditCaseDecision);

        String Decided_Date = getArguments().getString("DecisionDate");
        String Case_Type = getArguments().getString("CaseType");
        String Case_Number = getArguments().getString("CaseNumber");
        String Case_Year = getArguments().getString("CaseYear");
        String Case_Decision = getArguments().getString("CaseDecision");

        Date date1 = null;

        try {
            date1 = input.parse(Decided_Date);

        } catch (ParseException e) {
            e.printStackTrace();
        }

        CaseTitle.setText(Case_Type +" : "+Case_Number+" / "+Case_Year);
        EditDecisionDate.setText(output.format(date1));
        EditDecision.setText(Case_Decision);


        DecisionDate = new DatePickerDialog.OnDateSetListener() {

            @Override
            public void onDateSet(DatePicker view , int year , int monthOfYear ,
                                  int dayOfMonth) {
                // TODO Auto-generated method stub
                calendar.set(Calendar.YEAR , year);
                calendar.set(Calendar.MONTH , monthOfYear);
                calendar.set(Calendar.DAY_OF_MONTH , dayOfMonth);
                DecisionDate();
            }

        };

        EditDecisionDate.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                // TODO Auto-generated method stub
                new DatePickerDialog(getActivity() , DecisionDate , calendar
                        .get(Calendar.YEAR) , calendar.get(Calendar.MONTH) ,
                        calendar.get(Calendar.DAY_OF_MONTH)).show();
            }
        });


        btnEditCaseDecision.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                String decision_date = EditDecisionDate.getText().toString().trim();
                String mode_determination = String.valueOf(EditModeDetermination.getSelectedItem()).trim();
                String case_outcome = String.valueOf(EditCaseOutcome.getSelectedItem()).trim();
                String case_decision = EditDecision.getText().toString().trim();

                if (!decision_date.isEmpty()  && !case_outcome.isEmpty() && !mode_determination.isEmpty() && !case_decision.isEmpty()) {
                    updateEditCase(decision_date, case_outcome,mode_determination,case_decision);
                } else {
                    Toast.makeText(getActivity(),
                            (getResources().getString(R.string.fill_all_filed)), Toast.LENGTH_LONG)
                            .show();
                }

            }
        });

        getCaseOutcome();
        getCaseMode();
        return view;
    }

    private void getCaseOutcome(){

        // Creating volley request obj
        JsonArrayRequest movieReq = new JsonArrayRequest(AppConfig.URL_CASE_OUTCOME,
                new Response.Listener<JSONArray>() {
                    @Override
                    public void onResponse(JSONArray response) {
                        Log.d(TAG, response.toString());
                        hideDialog();

                        caseoutcome.add(getArguments().getString("CaseOutcome"));

                        try {
                            for (int i = 0; i < response.length(); i++) {

                                JSONObject obj = response.getJSONObject(i);
                                ModelOutcome court_case_outcome = new ModelOutcome();
                                court_case_outcome.setOutcome(obj.getString("outcome"));

                                OutComeModelArrayList.add(court_case_outcome);
                            }

                            for (int n = 0; n < OutComeModelArrayList.size(); n++){

                                caseoutcome.add(OutComeModelArrayList.get(n).getOutcome());
                            }

                            ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<>(getActivity() , simple_spinner_item , caseoutcome);
                            spinnerArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item); // The drop down view
                            EditCaseOutcome.setAdapter(spinnerArrayAdapter);
                            hideDialog();

                        }catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                },
                new Response.ErrorListener() {
                    @Override
                    public void onErrorResponse(VolleyError error) {
                        //displaying the error in toast if occurrs
                        Toast.makeText(getActivity(), error.getMessage(), Toast.LENGTH_SHORT).show();
                    }
                });

        // request queue
        AppController.getInstance().addToRequestQueue(movieReq);
    }
    private void getCaseMode(){
        // Creating volley request obj
        JsonArrayRequest movieReq = new JsonArrayRequest(AppConfig.URL_CASE_MODE,
                new Response.Listener<JSONArray>() {
                    @Override
                    public void onResponse(JSONArray response) {
                        Log.d(TAG, response.toString());
                        hideDialog();

                        casemode.add(getArguments().getString("ModeDetermination"));
                        try {
                            for (int i = 0; i < response.length(); i++) {

                                JSONObject obj = response.getJSONObject(i);
                                ModelMode court_case_mode = new ModelMode();
                                court_case_mode.setCaseMode(obj.getString("mode"));

                                ModeModelArrayList.add(court_case_mode);
                            }

                            for (int n = 0; n < ModeModelArrayList.size(); n++){

                                casemode.add(ModeModelArrayList.get(n).getCaseMode());
                            }

                            ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<>(getActivity() , simple_spinner_item , casemode);
                            spinnerArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item); // The drop down view
                            EditModeDetermination.setAdapter(spinnerArrayAdapter);
                            hideDialog();

                        }catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                },
                new Response.ErrorListener() {
                    @Override
                    public void onErrorResponse(VolleyError error) {
                        //displaying the error in toast if occurrs
                        Toast.makeText(getActivity(), error.getMessage(), Toast.LENGTH_SHORT).show();
                    }
                });

        // request queue
        AppController.getInstance().addToRequestQueue(movieReq);
    }
    private void updateEditCase(final String decision_date, final String case_outcome,final String mode_determination,
                            final String case_decision) {
        // Tag used to cancel the request
        String tag_string_req = "req_register";

        pDialog.setMessage((getResources().getString(R.string.case_updating)));
        showDialog();

        StringRequest strReq = new StringRequest(Request.Method.POST,
                AppConfig.URL_EDIT_DECIDED_CASE, new Response.Listener<String>() {

            @Override
            public void onResponse(String response) {
                Log.d(TAG, "Case Register Response: " + response);
                hideDialog();

                try {
                    JSONObject jObj = new JSONObject(response);
                    boolean error = jObj.getBoolean("error");
                    if (!error) {

                        Toast.makeText(getActivity(), (getResources().getString(R.string.case_editing)), Toast.LENGTH_LONG).show();

                        DecidedFragment fragment = new DecidedFragment();
                        FragmentManager fragmentManager = getFragmentManager();
                        FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();
                        fragmentTransaction.replace(R.id.nav_host_fragment, fragment, fragment.getTag());
                        fragmentTransaction.commit();


                    } else {

                        // Error occurred in registration. Get the error
                        // message
                        String errorMsg = jObj.getString("error_msg");
                        Toast.makeText(getActivity(),
                                errorMsg, Toast.LENGTH_LONG).show();
                    }
                } catch (JSONException e) {
                    e.printStackTrace();
                }

            }
        }, new Response.ErrorListener() {

            @Override
            public void onErrorResponse(VolleyError error) {

                Toast.makeText(getActivity(),
                        (getResources().getString(R.string.no_network)), Toast.LENGTH_LONG).show();
                hideDialog();
            }
        }) {



            @Override
            protected Map<String, String> getParams() {

                // Posting params to register url
                Map<String, String> params = new HashMap<>();
                DecisionFragment.pendingCase=new PendingCase();
                HashMap<String, String> user = db.getUserDetails();


                params.put("case_number", getArguments().getString("CaseNumber"));
                params.put("case_year",  getArguments().getString("CaseYear"));
                params.put("case_type",  getArguments().getString("CaseType"));
                params.put("courtID",user.get("courtID"));
                params.put("decided_date", decision_date);
                params.put("mode_determination", mode_determination);
                params.put("case_outcome", case_outcome);
                params.put("decision_remarks", case_decision);


                return params;

            }

        };

        // Adding request to request queue
        AppController.getInstance().addToRequestQueue(strReq, tag_string_req);
    }
    @Override
    public void onDestroy() {
        super.onDestroy();
        hideDialog();
    }
    private void showDialog() {
        if (!pDialog.isShowing())
            pDialog.show();
    }
    private void hideDialog() {
        if (pDialog.isShowing())
            pDialog.dismiss();
    }
    private void DecisionDate() {
        String myFormat = "dd-MM-YYY"; //In which you need put here
        SimpleDateFormat ToDate = new SimpleDateFormat(myFormat, Locale.ENGLISH);
        EditDecisionDate.setText(ToDate.format(calendar.getTime()));
    }



}