package com.example.primarycourt.activity.ui.pending;

import android.app.DatePickerDialog;
import android.app.ProgressDialog;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;

import com.android.volley.Request;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonArrayRequest;
import com.android.volley.toolbox.StringRequest;
import com.example.primarycourt.R;
import com.example.primarycourt.activity.ui.register.ModelParties;
import com.example.primarycourt.activity.ui.update.UpdateFragment;
import com.example.primarycourt.app.AppConfig;
import com.example.primarycourt.app.AppController;
import com.example.primarycourt.helper.ModelCaseType;
import com.example.primarycourt.helper.SQLiteHandler;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;

import static android.R.layout.simple_spinner_item;


public class EditPendingFragment extends Fragment {

    final Calendar myCalendar = Calendar.getInstance();
    private static final String TAG = EditPendingFragment.class.getSimpleName();

    private Spinner EditCaseType, EditAppellantGender, EditDefendantGender, EditAppellantPosition, EditDefendantPosition;
    EditText EditFilingDate, EditCaseNumber,EditCaseYear,EditCaseAppellant,EditAppellantAge,EditAppellantPhone,EditDefendantPhone;
    EditText EditDefendantAge,EditCaseDefendant,EditCaseClaim;
    Button btnEditPending;
    ProgressDialog pDialog;
    SQLiteHandler db;

    DatePickerDialog.OnDateSetListener date;

    DateFormat input = new SimpleDateFormat("yyyy-MM-dd");
    DateFormat output = new SimpleDateFormat("dd-MM-yyyy");


    private List<ModelCaseType> CaseTypeArrayList = new ArrayList<ModelCaseType>();
    private List<ModelParties> AppellantArrayList = new ArrayList<ModelParties>();
    private List<ModelParties> DefendantArrayList = new ArrayList<ModelParties>();
    private ArrayList<String> casetype = new ArrayList<String>();
    private ArrayList<String> appellantposition = new ArrayList<String>();
    private ArrayList<String> defendantposition = new ArrayList<String>();
    private ArrayList<String> appellantgender = new ArrayList<String>();
    private ArrayList<String> defendantgender = new ArrayList<String>();



    public View onCreateView(LayoutInflater inflater , ViewGroup container ,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View view = inflater.inflate(R.layout.fragment_edit_pending , container , false);

        EditFilingDate = view.findViewById(R.id.EditFilingDate);
        EditCaseNumber = view.findViewById(R.id.EditCaseNumber);
        EditCaseYear = view.findViewById(R.id.EditCaseYear);
        EditCaseType = view.findViewById(R.id.EditChoose_CaseType);

        EditCaseAppellant = view.findViewById(R.id.EditCaseAppellant);
        EditAppellantPosition = view.findViewById(R.id.EditChoose_Appellant_Position);
        EditAppellantAge = view.findViewById(R.id.EditAppellantAge);
        EditAppellantGender = view.findViewById(R.id.EditChoose_Gender_Appellant);
        EditAppellantPhone = view.findViewById(R.id.EditAppellantPhone);

        EditCaseDefendant = view.findViewById(R.id.EditCaseDefendant);
        EditDefendantPosition = view.findViewById(R.id.EditChoose_Defendant_Position);
        EditDefendantAge = view.findViewById(R.id.EditDefendantAge);
        EditDefendantGender = view.findViewById(R.id.EditChoose_Gender_Defendant);
        EditDefendantPhone = view.findViewById(R.id.EditDefendantPhone);
        EditCaseClaim = view.findViewById(R.id.EditCaseClaim);
        btnEditPending = view.findViewById(R.id.btnEditPending);

        pDialog = new ProgressDialog(getActivity());
        pDialog.setCancelable(false);
        db = new SQLiteHandler(getActivity());

        Date date1 = null;

        try {
            date1 = input.parse(getArguments().getString("filing_date"));

        } catch (ParseException e) {
            e.printStackTrace();
        }

        EditFilingDate.setText(output.format(date1));
        EditCaseNumber.setText(getArguments().getString("case_number"));
        EditCaseYear.setText(getArguments().getString("case_year"));

        EditCaseAppellant.setText(getArguments().getString("case_appellant"));
        EditAppellantAge.setText(getArguments().getString("appellant_age"));
        EditAppellantPhone.setText(getArguments().getString("appellant_phone"));

        EditCaseDefendant.setText(getArguments().getString("case_defendant"));
        EditDefendantAge.setText(getArguments().getString("defendant_age"));
        EditDefendantPhone.setText(getArguments().getString("defendant_phone"));

        EditCaseClaim.setText(getArguments().getString("case_claim"));


        date = new DatePickerDialog.OnDateSetListener() {

            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear,
                                  int dayOfMonth) {
                myCalendar.set(Calendar.YEAR, year);
                myCalendar.set(Calendar.MONTH, monthOfYear);
                myCalendar.set(Calendar.DAY_OF_MONTH, dayOfMonth);
                updateLabel();
                updateLabelCaseYear();
            }

        };

        EditFilingDate.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                new DatePickerDialog(getActivity(), date, myCalendar
                        .get(Calendar.YEAR), myCalendar.get(Calendar.MONTH),
                        myCalendar.get(Calendar.DAY_OF_MONTH)).show();
            }
        });

        EditCaseYear.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                new DatePickerDialog(getActivity(), date, myCalendar
                        .get(Calendar.YEAR), myCalendar.get(Calendar.MONTH),
                        myCalendar.get(Calendar.DAY_OF_MONTH)).show();
            }
        });


        // Register Button Click event
        btnEditPending.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                String filing_date = EditFilingDate.getText().toString().trim();
                String case_number = EditCaseNumber.getText().toString().trim();
                String case_year = EditCaseYear.getText().toString().trim();
                String case_type = String.valueOf(EditCaseType.getSelectedItem()).trim();
                String case_appellant = EditCaseAppellant.getText().toString().trim();
                String appellant_position = String.valueOf(EditAppellantPosition.getSelectedItem()).trim();
                String appellant_age = EditAppellantAge.getText().toString().trim();
                String appellant_phone = EditAppellantPhone.getText().toString().trim();
                String appellant_gender = String.valueOf(EditAppellantGender.getSelectedItem()).trim();
                String case_defendant = EditCaseDefendant.getText().toString().trim();
                String defendant_position =String.valueOf(EditDefendantPosition.getSelectedItem()).trim();
                String defendant_age = EditDefendantAge.getText().toString().trim();
                String defendant_phone = EditDefendantPhone.getText().toString().trim();
                String defendant_gender = String.valueOf(EditDefendantGender.getSelectedItem()).trim();
                String case_claim = EditCaseClaim.getText().toString().trim();




                if (!filing_date.isEmpty() && !case_number.isEmpty() && !case_year.isEmpty() && !case_type.equals(getResources().getString(R.string.choose_case_type))
                        && !case_appellant.isEmpty() && !appellant_position.equals(getResources().getString(R.string.appellant_position)) && !appellant_age.isEmpty() && !appellant_gender.isEmpty()
                        && !case_defendant.isEmpty() && !defendant_position.equals(getResources().getString(R.string.defendant_position)) && !defendant_age.isEmpty() && !defendant_gender.isEmpty()
                        && !case_claim.isEmpty()) {

                    editPendingCase(filing_date,case_number, case_year,case_type, case_appellant,appellant_position,appellant_age, appellant_phone,appellant_gender,
                            case_defendant,defendant_position,defendant_phone,defendant_age,defendant_gender,case_claim);
                } else {
                    Toast.makeText(getActivity(),
                            (getResources().getString(R.string.fill_all_filed)), Toast.LENGTH_LONG).show();
                }
            }
        });


        getCaseType();
        getAppellantPosition();
        getAppellantGender();
        getDefendantPosition();
        getDefendantGender();

        return view;
    }

    private void getCaseType(){

        // Creating volley request obj
        JsonArrayRequest movieReq = new JsonArrayRequest(AppConfig.URL_CASE_TYPE,
                new Response.Listener<JSONArray>() {
                    @Override
                    public void onResponse(JSONArray response) {
                        Log.d(TAG, response.toString());
                        hideDialog();

                        casetype.add(getArguments().getString("case_type"));
                        try {
                            for (int i = 0; i < response.length(); i++) {

                                JSONObject obj = response.getJSONObject(i);
                                ModelCaseType court_case_type = new ModelCaseType();
                                court_case_type.setCaseType(obj.getString("case_type_name"));

                                CaseTypeArrayList.add(court_case_type);
                            }

                            for (int n = 0; n < CaseTypeArrayList.size(); n++){

                                casetype.add(CaseTypeArrayList.get(n).getCaseType());
                            }

                            ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<>(getActivity() , simple_spinner_item , casetype);
                            spinnerArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item); // The drop down view
                            EditCaseType.setAdapter(spinnerArrayAdapter);
                            hideDialog();

                        }catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                },
                new Response.ErrorListener() {
                    @Override
                    public void onErrorResponse(VolleyError error) {
                        //displaying the error in toast if occurrs
                        Toast.makeText(getActivity(), error.getMessage(), Toast.LENGTH_SHORT).show();
                    }
                });

        // request queue
        AppController.getInstance().addToRequestQueue(movieReq);
    }
    private void getAppellantPosition(){

        // Creating volley request obj
        JsonArrayRequest movieReq = new JsonArrayRequest(AppConfig.URL_APPELLANT_POSITION,
                new Response.Listener<JSONArray>() {
                    @Override
                    public void onResponse(JSONArray response) {
                        Log.d(TAG, response.toString());
                        hideDialog();

                        appellantposition.add(getArguments().getString("appellant_position"));
                        try {
                            for (int i = 0; i < response.length(); i++) {

                                JSONObject obj = response.getJSONObject(i);
                                ModelParties court_appellant_position = new ModelParties();
                                court_appellant_position.setAppellantPosition(obj.getString("appellant_position"));

                                AppellantArrayList.add(court_appellant_position);
                            }

                            for (int n = 0; n < AppellantArrayList.size(); n++){

                                appellantposition.add(AppellantArrayList.get(n).getAppellantPosition());
                            }

                            ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<>(getActivity() , simple_spinner_item , appellantposition);
                            spinnerArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item); // The drop down view
                            EditAppellantPosition.setAdapter(spinnerArrayAdapter);
                            hideDialog();

                        }catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                },
                new Response.ErrorListener() {
                    @Override
                    public void onErrorResponse(VolleyError error) {
                        //displaying the error in toast if occurrs
                        Toast.makeText(getActivity(), error.getMessage(), Toast.LENGTH_SHORT).show();
                    }
                });

        // request queue
        AppController.getInstance().addToRequestQueue(movieReq);
    }
    private void getAppellantGender(){
        String Gender = getArguments().getString("appellant_gender");

        ArrayAdapter<CharSequence> adapter = ArrayAdapter.createFromResource(getContext(), R.array.gender, android.R.layout.simple_spinner_item);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        EditAppellantGender.setAdapter(adapter);
        if (Gender != null) {
            int spinnerPosition = adapter.getPosition(Gender);
            EditAppellantGender.setSelection(spinnerPosition);
        }
    }
    private void getDefendantGender(){
        String Gender = getArguments().getString("defendant_gender");

        ArrayAdapter<CharSequence> adapter = ArrayAdapter.createFromResource(getContext(), R.array.gender, android.R.layout.simple_spinner_item);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        EditDefendantGender.setAdapter(adapter);
        if (Gender != null) {
            int spinnerPosition = adapter.getPosition(Gender);
            EditDefendantGender.setSelection(spinnerPosition);
        }
    }
    private void getDefendantPosition(){

        // Creating volley request obj
        JsonArrayRequest movieReq = new JsonArrayRequest(AppConfig.URL_DEFENDANT_POSITION,
                new Response.Listener<JSONArray>() {
                    @Override
                    public void onResponse(JSONArray response) {
                        Log.d(TAG, response.toString());
                        hideDialog();

                        defendantposition.add(getArguments().getString("defendant_position"));
                        try {
                            for (int i = 0; i < response.length(); i++) {

                                JSONObject obj = response.getJSONObject(i);
                                ModelParties court_defendant_position = new ModelParties();
                                court_defendant_position.setDefendantPosition(obj.getString("defendant_position"));

                                DefendantArrayList.add(court_defendant_position);
                            }

                            for (int n = 0; n < DefendantArrayList.size(); n++){

                                defendantposition.add(DefendantArrayList.get(n).getDefendantPosition());
                            }

                            ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<>(getActivity() , simple_spinner_item , defendantposition);
                            spinnerArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item); // The drop down view
                            EditDefendantPosition.setAdapter(spinnerArrayAdapter);
                            hideDialog();

                        }catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                },
                new Response.ErrorListener() {
                    @Override
                    public void onErrorResponse(VolleyError error) {
                        //displaying the error in toast if occurrs
                        Toast.makeText(getActivity(), error.getMessage(), Toast.LENGTH_SHORT).show();
                    }
                });

        // request queue
        AppController.getInstance().addToRequestQueue(movieReq);
    }
    private void updateLabel() {
        String myFormat = "dd-MM-YYY"; //In which you need put here
        SimpleDateFormat sdf = new SimpleDateFormat(myFormat, Locale.ENGLISH);
        EditFilingDate.setText(sdf.format(myCalendar.getTime()));
    }
    private void updateLabelCaseYear() {
        String myFormat = "YYY"; //In which you need put here
        SimpleDateFormat sdf = new SimpleDateFormat(myFormat, Locale.ENGLISH);
        EditCaseYear.setText(sdf.format(myCalendar.getTime()));
    }
    private void editPendingCase(final String filing_date, final String case_number, final String case_year,
                              final String case_type, final String  case_appellant,final String appellant_position,final  String appellant_phone,final String  appellant_age,final String  appellant_gender,
                              final String case_defendant, final String defendant_position, final String defendant_phone, final String  defendant_age,final String  defendant_gender,
                              final String case_claim) {
        // Tag used to cancel the request
        String tag_string_req = "req_register";

        pDialog.setMessage(getResources().getString(R.string.case_registering));
        showDialog();

        StringRequest strReq = new StringRequest(Request.Method.POST,
                AppConfig.URL_EDIT_PENDING_CASE, new Response.Listener<String>() {

            @Override
            public void onResponse(String response) {
                Log.d(TAG, "Case Register Response: " + response);
                hideDialog();

                try {
                    JSONObject jObj = new JSONObject(response);
                    boolean error = jObj.getBoolean("error");
                    if (!error) {
                        // User successfully stored in MySQL comment
                        // Now store the user in sqlite comment

                        JSONObject user = jObj.getJSONObject("case");
                        String filing_date = user.getString("filing_date");
                        String case_year = user.getString("case_year");
//
//                        // Inserting row in users table comment
//                        db.addcase(filing_date, case_year);

                        Toast.makeText(getActivity(), (getResources().getString(R.string.case_editing)), Toast.LENGTH_LONG).show();


                        UpdateFragment fragment = new UpdateFragment();
                        FragmentManager fragmentManager = getFragmentManager();
                        FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();
                        fragmentTransaction.replace(R.id.nav_host_fragment, fragment, fragment.getTag());
                        fragmentTransaction.addToBackStack(null);
                        fragmentTransaction.commit();


                    } else {

                        // Error occurred in registration. Get the error
                        String errorMsg = jObj.getString("error_msg");
                        Toast.makeText(getActivity(),
                                errorMsg, Toast.LENGTH_LONG).show();
                    }
                } catch (JSONException e) {
                    e.printStackTrace();
                }

            }
        }, new Response.ErrorListener() {

            @Override
            public void onErrorResponse(VolleyError error) {

                Toast.makeText(getActivity(),
                        getResources().getString(R.string.no_network), Toast.LENGTH_LONG).show();
                hideDialog();
            }
        }) {



            @Override
            protected Map<String, String> getParams() {

                // Posting params to register url
                Map<String, String> params = new HashMap<>();
                HashMap<String, String> user = db.getUserDetails();

                params.put("caseID", getArguments().getString("caseID"));
                params.put("filing_date", filing_date);
                params.put("case_number", case_number);
                params.put("case_year", case_year);
                params.put("case_type", case_type);
                params.put("case_appellant", case_appellant);
                params.put("appellant_position",appellant_position);
                params.put("appellant_age", appellant_age);
                params.put("appellant_phone",appellant_phone);
                params.put("appellant_gender", appellant_gender);
                params.put("case_defendant", case_defendant);
                params.put("defendant_position",defendant_position);
                params.put("defendant_age", defendant_age);
                params.put("defendant_phone",defendant_phone);
                params.put("defendant_gender", defendant_gender);
                params.put("case_claim", case_claim);
                params.put("courtID",user.get("courtID"));

                return params;

            }

        };

        // Adding request to request queue
        AppController.getInstance().addToRequestQueue(strReq, tag_string_req);
    }

    private void showDialog() {
        if (!pDialog.isShowing())
            pDialog.show();
    }
    private void hideDialog() {
        if (pDialog.isShowing())
            pDialog.dismiss();
    }
}