package com.example.primarycourt.activity.ui.profile;

import android.app.ProgressDialog;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;

import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;
import com.example.primarycourt.R;
import com.example.primarycourt.app.AppConfig;
import com.example.primarycourt.helper.SQLiteHandler;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.HashMap;

import static com.example.primarycourt.app.AppController.TAG;

public class ProfileFragment extends Fragment implements View.OnClickListener{

    TextView fullname, userposition, username, court_name, email,phone;
    public static String uid;
    private SQLiteHandler db;
    public static String URL_USER_PROFILE;
    private ProgressDialog pDialog;
    RequestQueue requestQueue;
    Button ChangeCourt;

    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        View view = inflater.inflate(R.layout.fragment_profile , container, false);

        fullname = view.findViewById(R.id.fullname);
        userposition = view.findViewById(R.id.user_position);
        username = view.findViewById(R.id.username);
        court_name = view.findViewById(R.id.user_court);
        email = view.findViewById(R.id.email);
        phone = view.findViewById(R.id.phone);
        ChangeCourt = view.findViewById(R.id.ChangeCourt);

        pDialog = new ProgressDialog(getActivity());
        pDialog.setMessage("Loading...");
        pDialog.show();

        db = new SQLiteHandler(getActivity());
        HashMap<String, String> user = db.getUserDetails();
        requestQueue = Volley.newRequestQueue(getActivity());

        uid = user.get("uid");

        URL_USER_PROFILE  = AppConfig.IP_PATH+"get_user_profile.php?userID="+uid;


        getUserDetails();
        ChangeCourt.setOnClickListener(this);
        return  view;
    }



    private void getUserDetails(){
        StringRequest user_info = new StringRequest(Request.Method.GET,URL_USER_PROFILE,
                new Response.Listener<String>() {

                    @Override
                    public void onResponse(String response) {
                        Log.d(TAG, "Login Response: " + response);
                        hideDialog();

                        try {
                            JSONObject obj = new JSONObject(response);

                            String Full_name = obj.getString("name");
                            String User_Position = obj.getString("designation");
                            String User_Name = obj.getString("username");
                            String Court = obj.getString("court");
                            String Email = obj.getString("email");
                            String PhoneID = obj.getString("phoneID");

                            fullname.setText(Full_name);
                            userposition.setText(User_Position);
                            username.setText(User_Name);
                            court_name.setText(Court);
                            email.setText(Email);
                            phone.setText(PhoneID);
                        }
                        catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }, new Response.ErrorListener() {
            @Override
            // Handles errors that occur due to Volley
            public void onErrorResponse(VolleyError error) {
                Log.e("Volley", error.getMessage());
                hideDialog();
            }
        });
        requestQueue.add(user_info);
    }

    private void hideDialog() {
        if (pDialog != null) {
            pDialog.dismiss();
            pDialog = null;
        }
    }

    @Override
    public void onClick(View view) {
        Fragment fragment;

        switch (view.getId()){

            case R.id.ChangeCourt :
                fragment = new ChangeCourtFragment();
                FragmentManager fragmentManager = getFragmentManager();
                FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();
                fragmentTransaction.replace(R.id.nav_host_fragment , fragment , fragment.getTag());
                fragmentTransaction.addToBackStack(null);
                fragmentTransaction.commit();
                break;
        }


    }
}