package com.example.primarycourt.activity.ui.reassignment;

import android.app.ProgressDialog;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;

import com.android.volley.Request;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonArrayRequest;
import com.android.volley.toolbox.StringRequest;
import com.example.primarycourt.R;
import com.example.primarycourt.activity.ui.decided.CasedetailsFragment;
import com.example.primarycourt.activity.ui.pending.ModelMagistrate;
import com.example.primarycourt.activity.ui.pending.PendingFragment;
import com.example.primarycourt.activity.ui.update.DecisionFragment;
import com.example.primarycourt.app.AppConfig;
import com.example.primarycourt.app.AppController;
import com.example.primarycourt.helper.PendingCase;
import com.example.primarycourt.helper.SQLiteHandler;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static android.R.layout.simple_spinner_item;
import static com.example.primarycourt.activity.ui.pending.assignFragment.URL_GET_MAGISTRATE;
import static com.example.primarycourt.app.AppConfig.IP_PATH;

public class ReassignFragment extends Fragment {

    private static final String TAG = ReassignFragment.class.getSimpleName();

    Spinner CaseMagistratae;
    TextView courtID;
    TextView Case_Type;
    TextView Case_Number;
    TextView Case_Year;
    TextView Appellant;
    TextView Defendant;
    TextView Claim;
    TextView Filing_Date;
    TextView Case_Magistrate;
    Button btnCaseReassign;

    public static String user_courtID;
    public static PendingCase pendingCase;
    SQLiteHandler db;
    ProgressDialog pDialog;

    private List<ModelMagistrate> CourtMagistrateList = new ArrayList<ModelMagistrate>();
    private ArrayList<String> magistrates = new ArrayList<String>();

    public View onCreateView(LayoutInflater inflater , ViewGroup container ,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View view = inflater.inflate(R.layout.fragment_reassign , container , false);

        // SQLite database handler
        db = new SQLiteHandler(getActivity());

        courtID = view.findViewById(R.id.courtID);
        Case_Type = view.findViewById(R.id.case_type);
        Case_Number = view.findViewById(R.id.case_number);
        Case_Year = view.findViewById(R.id.case_year);
        Appellant = view.findViewById(R.id.view_appellant);
        Defendant = view.findViewById(R.id.view_defendant);
        Claim = view.findViewById(R.id.view_claim);
        Filing_Date = view.findViewById(R.id.view_filing_date);
        Case_Magistrate = view.findViewById(R.id.case_from);
        CaseMagistratae = view.findViewById(R.id.magistrate_list);
        btnCaseReassign = view.findViewById(R.id.btn_reassign);

        String CaseType = getArguments().getString("case_type");
        String CaseNumber = getArguments().getString("case_number");
        String CaseYear = getArguments().getString("case_year");
        String CaseAppellant = getArguments().getString("case_appellant");
        String CaseDefendant = getArguments().getString("case_defendant");
        String CaseClaim = getArguments().getString("case_claim");
        String FilingDate = getArguments().getString("filing_date");
        String CaseMagistrate = getArguments().getString("assigned_to");

        CasedetailsFragment.pendingCase = new PendingCase();
        Map<String, String> params = new HashMap<>();
        HashMap<String, String> user = db.getUserDetails();
        user_courtID = user.get("courtID");
        courtID.setText(user.get("courtID"));

        Case_Type.setText(CaseType);
        Case_Number.setText(CaseNumber);
        Case_Year.setText(CaseYear);
        Appellant.setText(CaseAppellant);
        Defendant.setText(CaseDefendant);
        Claim.setText(CaseClaim);
        Filing_Date.setText(FilingDate);
        Case_Magistrate.setText(CaseMagistrate);

        // Progress dialog
        pDialog = new ProgressDialog(getActivity());
        pDialog.setCancelable(false);

        // SQLite database handler
        db = new SQLiteHandler(getActivity());


        // Register Button Click event
        btnCaseReassign.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                String reassigned_to = String.valueOf(CaseMagistratae.getSelectedItem()).trim();

                if (!reassigned_to.equals(getResources().getString(R.string.choose_magistrate))) {
                    reassignCase(reassigned_to);
                } else {
                    Toast.makeText(getActivity(),
                            (getResources().getString(R.string.fill_all_filed)), Toast.LENGTH_LONG)
                            .show();
                }
            }
        });

        getMagistrates();

        return view;
    }


    /** Function to call Spinner
     * To call Magistrate based on  call
     * **/
    private void getMagistrates(){
        db = new SQLiteHandler(getActivity());
        HashMap<String, String> user = db.getUserDetails();

        user_courtID = user.get("courtID");
//        accessID = Integer.parseInt(user.get("accessID"));

        URL_GET_MAGISTRATE = IP_PATH+"get_magistrate.php?courtID="+user_courtID;

        // Creating volley request obj
        JsonArrayRequest movieReq = new JsonArrayRequest(URL_GET_MAGISTRATE,
                new Response.Listener<JSONArray>() {
                    @Override
                    public void onResponse(JSONArray response) {
                        Log.d(TAG, response.toString());
                        hideDialog();

                        magistrates.add(getResources().getString(R.string.choose_magistrate));
                        try {
                            for (int i = 0; i < response.length(); i++) {

                                JSONObject obj = response.getJSONObject(i);
                                ModelMagistrate court_magistrate = new ModelMagistrate();
                                court_magistrate.setMagistrate(obj.getString("magistrate"));

                                CourtMagistrateList.add(court_magistrate);
                            }

                            for (int n = 0; n < CourtMagistrateList.size(); n++){

                                magistrates.add(CourtMagistrateList.get(n).getMagistrate());
                            }

                            ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<>(getActivity() , simple_spinner_item , magistrates);
                            spinnerArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item); // The drop down view
                            CaseMagistratae.setAdapter(spinnerArrayAdapter);
                            hideDialog();

                        }catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                },
                new Response.ErrorListener() {
                    @Override
                    public void onErrorResponse(VolleyError error) {
                        //displaying the error in toast if occurrs
                        Toast.makeText(getActivity(), error.getMessage(), Toast.LENGTH_SHORT).show();
                    }
                });

        // request queue
        AppController.getInstance().addToRequestQueue(movieReq);
    }



    /**
     * Function to store user in MySQL database will post params(tag, name,
     * email, password) to register url
     * */

    private void reassignCase(final String reassigned_to) {
        // Tag used to cancel the request
        String tag_string_req = "req_register";

        pDialog.setMessage(getResources().getString(R.string.case_assigning));
        showDialog();

        StringRequest strReq = new StringRequest(Request.Method.POST,
                AppConfig.URL_REASSIGN_CASE, new Response.Listener<String>() {

            @Override
            public void onResponse(String response) {
                Log.d(TAG, "Case Assignment Response: " + response);
                hideDialog();

                try {
                    JSONObject jObj = new JSONObject(response);
                    boolean error = jObj.getBoolean("error");
                    if (!error) {


                        Toast.makeText(getActivity(), getResources().getString(R.string.case_assigned), Toast.LENGTH_LONG).show();


                        ReassignmentListFragment fragment = new ReassignmentListFragment();
                        FragmentManager fragmentManager = getFragmentManager();
                        FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();
                        fragmentTransaction.replace(R.id.nav_host_fragment, fragment, fragment.getTag());
                        fragmentTransaction.commit();


                    } else {

                        // Error occurred in registration. Get the error
                        // message
                        String errorMsg = jObj.getString("error_msg");
                        Toast.makeText(getActivity(),
                                errorMsg, Toast.LENGTH_LONG).show();
                    }
                } catch (JSONException e) {
                    e.printStackTrace();
                }

            }
        }, new Response.ErrorListener() {

            @Override
            public void onErrorResponse(VolleyError error) {

                Toast.makeText(getActivity(),
                        getResources().getString(R.string.no_network), Toast.LENGTH_LONG).show();
                hideDialog();
            }
        }) {



            @Override
            protected Map<String, String> getParams() {

                // Posting params to register url
                Map<String, String> params = new HashMap<>();
                DecisionFragment.pendingCase=new PendingCase();
                HashMap<String, String> user = db.getUserDetails();


                params.put("case_number", getArguments().getString("case_number"));
                params.put("case_year",  getArguments().getString("case_year"));
                params.put("case_type",  getArguments().getString("case_type"));
                params.put("courtID",user.get("courtID"));
                params.put("assigned_to",reassigned_to);


                return params;

            }

        };

        // Adding request to request queue
        AppController.getInstance().addToRequestQueue(strReq, tag_string_req);
    }



    private void showDialog() {
        if (!pDialog.isShowing())
            pDialog.show();
    }

    private void hideDialog() {
        if (pDialog.isShowing())
            pDialog.dismiss();
    }

}
