package com.example.primarycourt.activity.ui.register;

import android.app.DatePickerDialog;
import android.app.ProgressDialog;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;

import com.android.volley.Request;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonArrayRequest;
import com.android.volley.toolbox.StringRequest;
import com.example.primarycourt.R;
import com.example.primarycourt.app.AppConfig;
import com.example.primarycourt.app.AppController;
import com.example.primarycourt.helper.ModelCaseType;
import com.example.primarycourt.helper.SQLiteHandler;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.TimeZone;

import static android.R.layout.simple_spinner_item;

public class RegisterFragment extends Fragment {
    final Calendar myCalendar = Calendar.getInstance(TimeZone.getTimeZone("UTC"));
    private static final String TAG = RegisterFragment.class.getSimpleName();

    private Spinner CaseType, AppellantGender, DefendantGender, AppellantPosition, DefendantPosition;
    EditText FilingDate;
    EditText CaseNumber;
    EditText CaseYear;
    EditText CaseAppellant;
    EditText AppellantAge;
    EditText AppellantPhone,DefendantPhone;
    EditText DefendantAge;
    EditText CaseDefendant;
    EditText CaseClaim;
    Button btnCase_Register;
    ProgressDialog pDialog;
    SQLiteHandler db;

    DatePickerDialog.OnDateSetListener date;
    private List<ModelCaseType> CaseTypeArrayList = new ArrayList<ModelCaseType>();
    private List<ModelParties> AppellantArrayList = new ArrayList<ModelParties>();
    private List<ModelParties> DefendantArrayList = new ArrayList<ModelParties>();
    private ArrayList<String> casetype = new ArrayList<String>();
    private ArrayList<String> appellantposition = new ArrayList<String>();
    private ArrayList<String> defendantposition = new ArrayList<String>();


    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View view = inflater.inflate(R.layout.fragment_register, container, false);

//        addListenerOnSpinnerItemSelection();

        FilingDate = view.findViewById(R.id.FilingDate);
        CaseNumber = view.findViewById(R.id.CaseNumber);
        CaseYear = view.findViewById(R.id.CaseYear);
        CaseType = view.findViewById(R.id.Choose_CaseType);

        CaseAppellant = view.findViewById(R.id.CaseAppellant);
        AppellantPosition = view.findViewById(R.id.Choose_Appellant_Position);
        AppellantAge = view.findViewById(R.id.AppellantAge);
        AppellantGender = view.findViewById(R.id.Choose_Gender_Appellant);
        AppellantPhone = view.findViewById(R.id.AppellantPhone);

        CaseDefendant = view.findViewById(R.id.CaseDefendant);
        DefendantPosition = view.findViewById(R.id. Choose_Defendant_Position);
        DefendantAge = view.findViewById(R.id.DefendantAge);
        DefendantGender = view.findViewById(R.id.Choose_Gender_Defendant);
        DefendantPhone = view.findViewById(R.id.DefendantPhone);
        CaseClaim = view.findViewById(R.id.CaseClaim);
        btnCase_Register = view.findViewById(R.id.btnCase_Register);


        // Progress dialog
        pDialog = new ProgressDialog(getActivity());
        pDialog.setCancelable(false);

        // SQLite database handler
        db = new SQLiteHandler(getActivity());

        //for first spinner




        // Register Button Click event
        btnCase_Register.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                String filing_date = FilingDate.getText().toString().trim();
                String case_number = CaseNumber.getText().toString().trim();
                String case_year = CaseYear.getText().toString().trim();
                String case_type = String.valueOf(CaseType.getSelectedItem()).trim();
                String case_appellant = CaseAppellant.getText().toString().trim();
                String appellant_position = String.valueOf(AppellantPosition.getSelectedItem()).trim();
                String appellant_age = AppellantAge.getText().toString().trim();
                String appellant_phone = AppellantPhone.getText().toString().trim();
                String appellant_gender = String.valueOf(AppellantGender.getSelectedItem()).trim();
                String case_defendant = CaseDefendant.getText().toString().trim();
                String defendant_position =String.valueOf(DefendantPosition.getSelectedItem()).trim();
                String defendant_age = DefendantAge.getText().toString().trim();
                String defendant_phone = DefendantPhone.getText().toString().trim();
                String defendant_gender = String.valueOf(DefendantGender.getSelectedItem()).trim();
                String case_claim = CaseClaim.getText().toString().trim();




                if (!filing_date.isEmpty() && !case_number.isEmpty() && !case_year.isEmpty() && !case_type.equals(getResources().getString(R.string.choose_case_type))
                        && !case_appellant.isEmpty() && !appellant_position.equals(getResources().getString(R.string.appellant_position)) && !appellant_age.isEmpty() && !appellant_gender.isEmpty()
                        && !case_defendant.isEmpty() && !defendant_position.equals(getResources().getString(R.string.defendant_position)) && !defendant_age.isEmpty() && !defendant_gender.isEmpty()
                        && !case_claim.isEmpty()) {

                    registerCase(filing_date,case_number, case_year,case_type, case_appellant,appellant_position,appellant_age, appellant_phone,appellant_gender,
                            case_defendant,defendant_position,defendant_phone,defendant_age,defendant_gender,case_claim);
                } else {
                    Toast.makeText(getActivity(),
                            (getResources().getString(R.string.fill_all_filed)), Toast.LENGTH_LONG).show();
                }
            }
        });



        date = new DatePickerDialog.OnDateSetListener() {

            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear,
                                  int dayOfMonth) {
                // TODO Auto-generated method stub
                myCalendar.set(Calendar.YEAR, year);
                myCalendar.set(Calendar.MONTH, monthOfYear);
                myCalendar.set(Calendar.DAY_OF_MONTH, dayOfMonth);
                myCalendar.getDisplayName(Calendar.MONTH,Calendar.SHORT,Locale.getDefault());
                updateLabel();
                updateLabelCaseYear();
            }

        };

        FilingDate.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                // TODO Auto-generated method stub
                new DatePickerDialog(getActivity(), date, myCalendar
                        .get(Calendar.YEAR), myCalendar.get(Calendar.MONTH),
                        myCalendar.get(Calendar.DAY_OF_MONTH)).show();
            }
        });

        CaseYear.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                // TODO Auto-generated method stub
                new DatePickerDialog(getActivity(), date, myCalendar
                        .get(Calendar.YEAR), myCalendar.get(Calendar.MONTH),
                        myCalendar.get(Calendar.DAY_OF_MONTH)).show();
            }
        });


        getCaseType();
        getAppellantPosition();
        getDefendantPosition();


        return view;
    }


    /** Function to call Spinner
     * To call Case Type
     * **/
    private void getCaseType(){

        // Creating volley request obj
        JsonArrayRequest movieReq = new JsonArrayRequest(AppConfig.URL_CASE_TYPE,
                new Response.Listener<JSONArray>() {
                    @Override
                    public void onResponse(JSONArray response) {
                        Log.d(TAG, response.toString());
                        hideDialog();

                        casetype.add(getResources().getString(R.string.choose_case_type));
                        try {
                            for (int i = 0; i < response.length(); i++) {

                                JSONObject obj = response.getJSONObject(i);
                                ModelCaseType court_case_type = new ModelCaseType();
                                court_case_type.setCaseType(obj.getString("case_type_name"));

                                CaseTypeArrayList.add(court_case_type);
                            }

                            for (int n = 0; n < CaseTypeArrayList.size(); n++){

                                casetype.add(CaseTypeArrayList.get(n).getCaseType());
                            }

                            ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<>(getActivity() , simple_spinner_item , casetype);
                            spinnerArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item); // The drop down view
                            CaseType.setAdapter(spinnerArrayAdapter);
                            hideDialog();

                        }catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                },
                new Response.ErrorListener() {
                    @Override
                    public void onErrorResponse(VolleyError error) {
                        //displaying the error in toast if occurrs
                        Toast.makeText(getActivity(), error.getMessage(), Toast.LENGTH_SHORT).show();
                    }
                });

        // request queue
        AppController.getInstance().addToRequestQueue(movieReq);
    }

    /** Function to call Spinner
     * To call Appellant Position
     * **/
    private void getAppellantPosition(){

        // Creating volley request obj
        JsonArrayRequest movieReq = new JsonArrayRequest(AppConfig.URL_APPELLANT_POSITION,
                new Response.Listener<JSONArray>() {
                    @Override
                    public void onResponse(JSONArray response) {
                        Log.d(TAG, response.toString());
                        hideDialog();

                        appellantposition.add(getResources().getString(R.string.appellant_position));
                        try {
                            for (int i = 0; i < response.length(); i++) {

                                JSONObject obj = response.getJSONObject(i);
                                ModelParties court_appellant_position = new ModelParties();
                                court_appellant_position.setAppellantPosition(obj.getString("appellant_position"));

                                AppellantArrayList.add(court_appellant_position);
                            }

                            for (int n = 0; n < AppellantArrayList.size(); n++){

                                appellantposition.add(AppellantArrayList.get(n).getAppellantPosition());
                            }

                            ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<>(getActivity() , simple_spinner_item , appellantposition);
                            spinnerArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item); // The drop down view
                            AppellantPosition.setAdapter(spinnerArrayAdapter);
                            hideDialog();

                        }catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                },
                new Response.ErrorListener() {
                    @Override
                    public void onErrorResponse(VolleyError error) {
                        //displaying the error in toast if occurrs
                        Toast.makeText(getActivity(), error.getMessage(), Toast.LENGTH_SHORT).show();
                    }
                });

        // request queue
        AppController.getInstance().addToRequestQueue(movieReq);
    }

    /** Function to call Spinner
     * To call Defendant Position
     * **/
    private void getDefendantPosition(){

        // Creating volley request obj
        JsonArrayRequest movieReq = new JsonArrayRequest(AppConfig.URL_DEFENDANT_POSITION,
                new Response.Listener<JSONArray>() {
                    @Override
                    public void onResponse(JSONArray response) {
                        Log.d(TAG, response.toString());
                        hideDialog();

                        defendantposition.add(getResources().getString(R.string.defendant_position));
                        try {
                            for (int i = 0; i < response.length(); i++) {

                                JSONObject obj = response.getJSONObject(i);
                                ModelParties court_defendant_position = new ModelParties();
                                court_defendant_position.setDefendantPosition(obj.getString("defendant_position"));

                                DefendantArrayList.add(court_defendant_position);
                            }

                            for (int n = 0; n < DefendantArrayList.size(); n++){

                                defendantposition.add(DefendantArrayList.get(n).getDefendantPosition());
                            }

                            ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<>(getActivity() , simple_spinner_item , defendantposition);
                            spinnerArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item); // The drop down view
                            DefendantPosition.setAdapter(spinnerArrayAdapter);
                            hideDialog();

                        }catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                },
                new Response.ErrorListener() {
                    @Override
                    public void onErrorResponse(VolleyError error) {
                        //displaying the error in toast if occurrs
                        Toast.makeText(getActivity(), error.getMessage(), Toast.LENGTH_SHORT).show();
                    }
                });

        // request queue
        AppController.getInstance().addToRequestQueue(movieReq);
    }

    /**
     * Function to store user in MySQL database will post params(tag, name,
     * email, password) to register url
     * */


    private void registerCase(final String filing_date, final String case_number, final String case_year,
                              final String case_type, final String  case_appellant,final String appellant_position,final  String appellant_phone,final String  appellant_age,final String  appellant_gender,
                              final String case_defendant, final String defendant_position, final String defendant_phone, final String  defendant_age,final String  defendant_gender,
                              final String case_claim) {
        // Tag used to cancel the request
        String tag_string_req = "req_register";

        pDialog.setMessage(getResources().getString(R.string.case_registering));
        showDialog();

        StringRequest strReq = new StringRequest(Request.Method.POST,
                AppConfig.URL_CASE_REGISTER, new Response.Listener<String>() {

            @Override
            public void onResponse(String response) {
                Log.d(TAG, "Case Register Response: " + response);
                hideDialog();

                try {
                    JSONObject jObj = new JSONObject(response);
                    boolean error = jObj.getBoolean("error");
                    if (!error) {
                        // User successfully stored in MySQL comment
                        // Now store the user in sqlite comment

                        JSONObject user = jObj.getJSONObject("case");
                        String filing_date = user.getString("filing_date");
                        String case_year = user.getString("case_year");
//
//                        // Inserting row in users table comment
//                        db.addcase(filing_date, case_year);

                        Toast.makeText(getActivity(), (getResources().getString(R.string.case_registred)), Toast.LENGTH_LONG).show();


                        RegisterFragment fragment = new RegisterFragment();
                        FragmentManager fragmentManager = getFragmentManager();
                        FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();
                        fragmentTransaction.replace(R.id.nav_host_fragment, fragment, fragment.getTag());
                        fragmentTransaction.addToBackStack(null);
                        fragmentTransaction.commit();


                    } else {

                        // Error occurred in registration. Get the error
                        String errorMsg = jObj.getString("error_msg");
                        Toast.makeText(getActivity(),
                                errorMsg, Toast.LENGTH_LONG).show();
                    }
                } catch (JSONException e) {
                    e.printStackTrace();
                }

            }
        }, new Response.ErrorListener() {

            @Override
            public void onErrorResponse(VolleyError error) {

                Toast.makeText(getActivity(),
                        getResources().getString(R.string.no_network), Toast.LENGTH_LONG).show();
                hideDialog();
            }
        }) {



            @Override
            protected Map<String, String> getParams() {

                // Posting params to register url
                Map<String, String> params = new HashMap<>();
                HashMap<String, String> user = db.getUserDetails();

                params.put("filing_date", filing_date);
                params.put("case_number", case_number);
                params.put("case_year", case_year);
                params.put("case_type", case_type);
                params.put("case_appellant", case_appellant);
                params.put("appellant_position",appellant_position);
                params.put("appellant_age", appellant_age);
                params.put("appellant_phone",appellant_phone);
                params.put("appellant_gender", appellant_gender);
                params.put("case_defendant", case_defendant);
                params.put("defendant_position",defendant_position);
                params.put("defendant_age", defendant_age);
                params.put("defendant_phone",defendant_phone);
                params.put("defendant_gender", defendant_gender);
                params.put("case_claim", case_claim);
                params.put("courtID",user.get("courtID"));
                params.put("user_uid",user.get("uid"));

                return params;

            }

        };

        // Adding request to request queue
        AppController.getInstance().addToRequestQueue(strReq, tag_string_req);
    }



    private void updateLabel() {
        String myFormat = "dd-MM-yyyy"; //In which you need put here
        SimpleDateFormat sdf = new SimpleDateFormat(myFormat, Locale.ENGLISH);
        FilingDate.setText(sdf.format(myCalendar.getTime()));
    }

    private void updateLabelCaseYear() {
        String myFormat = "yyyy"; //In which you need put here
        SimpleDateFormat sdf = new SimpleDateFormat(myFormat, Locale.ENGLISH);
        CaseYear.setText(sdf.format(myCalendar.getTime()));
    }


    private void showDialog() {
        if (!pDialog.isShowing())
            pDialog.show();
    }

    private void hideDialog() {
        if (pDialog.isShowing())
            pDialog.dismiss();
    }



}