package com.example.primarycourt.activity.ui.update;

import android.app.DatePickerDialog;
import android.app.ProgressDialog;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;

import com.android.volley.Request;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonArrayRequest;
import com.android.volley.toolbox.StringRequest;
import com.example.primarycourt.R;
import com.example.primarycourt.activity.ui.pending.EditPendingFragment;
import com.example.primarycourt.app.AppConfig;
import com.example.primarycourt.app.AppController;
import com.example.primarycourt.helper.ModelMode;
import com.example.primarycourt.helper.ModelOutcome;
import com.example.primarycourt.helper.PendingCase;
import com.example.primarycourt.helper.SQLiteHandler;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;

import static android.R.layout.simple_spinner_item;


public class DecisionFragment extends Fragment {

    final Calendar myCalendar = Calendar.getInstance();
    private static final String TAG = DecisionFragment.class.getSimpleName();

    Spinner ModeDetermination;
    Spinner CaseOutcome;
    TextView courtID;
    TextView Tcase_type;
    TextView Tcase_number;
    TextView Tcase_year;
    TextView Tappellant;
    TextView Tdefendant;
    TextView Tclaim;
    TextView Tfiling_date;
    TextView CaseMagistrate;
    TextView DecisionDate;
    TextView CaseDecision;
    Button btnCaseUpdate,btn_editInfo;

    ProgressDialog pDialog;
    static ProgressDialog mProgressDialog;

    DatePickerDialog.OnDateSetListener date;

    public static String user_courtID;
    public static PendingCase pendingCase;
    SQLiteHandler db;

    private ArrayList<ModelOutcome> OutComeModelArrayList = new ArrayList<ModelOutcome>();
    private ArrayList<ModelMode> ModeModelArrayList = new ArrayList<ModelMode>();
    private ArrayList<String> caseoutcome = new ArrayList<String>();
    private ArrayList<String> casemode = new ArrayList<String>();


    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View view = inflater.inflate(R.layout.fragment_decision, container, false);

        // SQLite database handler
        db = new SQLiteHandler(getActivity());

        courtID=view.findViewById(R.id.courtID);
        Tcase_type=view.findViewById(R.id.case_type);
        Tcase_number=view.findViewById(R.id.case_number);
        Tcase_year=view.findViewById(R.id.case_year);
        Tappellant = view.findViewById(R.id.view_appellant);
        Tdefendant = view.findViewById(R.id.view_defendant);
        Tclaim = view.findViewById(R.id.view_claim);
        Tfiling_date = view.findViewById(R.id.view_filing_date);
        CaseMagistrate = view.findViewById(R.id.view_magistrate);
        DecisionDate = view.findViewById(R.id.decision_date);

        ModeDetermination = view.findViewById(R.id.mode_determination);
        CaseOutcome = view.findViewById(R.id.case_outcome);

        CaseDecision = view.findViewById(R.id.decision);
        btnCaseUpdate = view.findViewById(R.id.btncase_update);
        btn_editInfo = view.findViewById(R.id.btn_editInfo);


        String CaseType = getArguments().getString("case_type");
        String CaseNumber = getArguments().getString("case_number");
        String CaseYear = getArguments().getString("case_year");
        String CaseAppellant = getArguments().getString("case_appellant");
        String CaseDefendant = getArguments().getString("case_defendant");
        String CaseClaim = getArguments().getString("case_claim");
        String FillingDate = getArguments().getString("filing_date");
        String Magistrate = getArguments().getString("assigned_to");


        DecisionFragment.pendingCase = new PendingCase();
        Map<String, String> params = new HashMap<>();
        HashMap<String, String> user = db.getUserDetails();

        user_courtID = user.get("courtID");

        courtID.setText(user.get("courtID"));
        Tcase_type.setText(CaseType);
        Tcase_number.setText(CaseNumber);
        Tcase_year.setText(CaseYear);
        Tappellant.setText(CaseAppellant);
        Tdefendant.setText(CaseDefendant);
        Tclaim.setText(CaseClaim);
        Tfiling_date.setText(FillingDate);
        CaseMagistrate.setText(Magistrate);



        // Progress dialog
        pDialog = new ProgressDialog(getActivity());
        pDialog.setCancelable(false);

        // SQLite database handler
        db = new SQLiteHandler(getActivity());



        // Register Button Click event
        btnCaseUpdate.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                String decision_date = DecisionDate.getText().toString().trim();
                String mode_determination = String.valueOf(ModeDetermination.getSelectedItem()).trim();
                String case_outcome = String.valueOf(CaseOutcome.getSelectedItem()).trim();
                String case_decision = CaseDecision.getText().toString().trim();



                if (!decision_date.isEmpty()  && !case_outcome.equals(getResources().getString(R.string.case_outcome_label))
                        && !mode_determination.equals(getResources().getString(R.string.case_determination_label)) && !case_decision.isEmpty()) {
                    updateCase(decision_date, case_outcome,mode_determination,case_decision);
                } else {
                    Toast.makeText(getActivity(), (getResources().getString(R.string.fill_all_filed)), Toast.LENGTH_LONG).show();
                }
            }
        });




        date = new DatePickerDialog.OnDateSetListener() {

            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear,
                                  int dayOfMonth) {
                // TODO Auto-generated method stub
                myCalendar.set(Calendar.YEAR, year);
                myCalendar.set(Calendar.MONTH, monthOfYear);
                myCalendar.set(Calendar.DAY_OF_MONTH, dayOfMonth);
                updateLabel();
            }

        };

        DecisionDate.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                // TODO Auto-generated method stub
                new DatePickerDialog(getActivity(), date, myCalendar
                        .get(Calendar.YEAR), myCalendar.get(Calendar.MONTH),
                        myCalendar.get(Calendar.DAY_OF_MONTH)).show();
            }
        });


        btn_editInfo.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                Bundle bundle = new Bundle();
                bundle.putString("caseID",getArguments().getString("caseID"));
                bundle.putString("case_type" , getArguments().getString("case_type"));
                bundle.putString("case_number" , getArguments().getString("case_number"));
                bundle.putString("case_year" , getArguments().getString("case_year"));
                bundle.putString("case_appellant" , getArguments().getString("case_appellant"));
                bundle.putString("case_defendant" , getArguments().getString("case_defendant"));
                bundle.putString("case_claim" , getArguments().getString("case_claim"));
                bundle.putString("filing_date" , getArguments().getString("filing_date"));

                bundle.putString("appellant_position" , getArguments().getString("appellant_position"));
                bundle.putString("appellant_age" , getArguments().getString("appellant_age"));
                bundle.putString("appellant_gender" , getArguments().getString("appellant_gender"));
                bundle.putString("appellant_phone" , getArguments().getString("appellant_phone"));
                bundle.putString("defendant_position" , getArguments().getString("defendant_position"));
                bundle.putString("defendant_age" , getArguments().getString("defendant_age"));
                bundle.putString("defendant_gender" , getArguments().getString("defendant_gender"));
                bundle.putString("defendant_phone" , getArguments().getString("defendant_phone"));

                EditPendingFragment fragment = new EditPendingFragment();
                FragmentManager fragmentManager = getFragmentManager();
                FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();
                fragment.setArguments(bundle);
                fragmentTransaction.replace(R.id.nav_host_fragment, fragment, fragment.getTag());
                fragmentTransaction.addToBackStack(null);
                fragmentTransaction.commit();
            }
        });



        getCaseOutcome();
        getCaseMode();
        return view;
    }



    private void getCaseOutcome(){

        // Creating volley request obj
        JsonArrayRequest movieReq = new JsonArrayRequest(AppConfig.URL_CASE_OUTCOME,
                new Response.Listener<JSONArray>() {
                    @Override
                    public void onResponse(JSONArray response) {
                        Log.d(TAG, response.toString());
                        hideDialog();

                        caseoutcome.add(getResources().getString(R.string.case_outcome_label));
                        try {
                            for (int i = 0; i < response.length(); i++) {

                                JSONObject obj = response.getJSONObject(i);
                                ModelOutcome court_case_outcome = new ModelOutcome();
                                court_case_outcome.setOutcome(obj.getString("outcome"));

                                OutComeModelArrayList.add(court_case_outcome);
                            }

                            for (int n = 0; n < OutComeModelArrayList.size(); n++){

                                caseoutcome.add(OutComeModelArrayList.get(n).getOutcome());
                            }

                            ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<>(getActivity() , simple_spinner_item , caseoutcome);
                            spinnerArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item); // The drop down view
                            CaseOutcome.setAdapter(spinnerArrayAdapter);
                            hideDialog();

                        }catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                },
                new Response.ErrorListener() {
                    @Override
                    public void onErrorResponse(VolleyError error) {
                        //displaying the error in toast if occurrs
                        Toast.makeText(getActivity(), error.getMessage(), Toast.LENGTH_SHORT).show();
                    }
                });

        // request queue
        AppController.getInstance().addToRequestQueue(movieReq);
    }
    private void getCaseMode(){

        // Creating volley request obj
        JsonArrayRequest movieReq = new JsonArrayRequest(AppConfig.URL_CASE_MODE,
                new Response.Listener<JSONArray>() {
                    @Override
                    public void onResponse(JSONArray response) {
                        Log.d(TAG, response.toString());
                        hideDialog();

                        casemode.add(getResources().getString(R.string.case_determination_label));
                        try {
                            for (int i = 0; i < response.length(); i++) {

                                JSONObject obj = response.getJSONObject(i);
                                ModelMode court_case_mode = new ModelMode();
                                court_case_mode.setCaseMode(obj.getString("mode"));

                                ModeModelArrayList.add(court_case_mode);
                            }

                            for (int n = 0; n < ModeModelArrayList.size(); n++){

                                casemode.add(ModeModelArrayList.get(n).getCaseMode());
                            }

                            ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<>(getActivity() , simple_spinner_item , casemode);
                            spinnerArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item); // The drop down view
                            ModeDetermination.setAdapter(spinnerArrayAdapter);
                            hideDialog();

                        }catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                },
                new Response.ErrorListener() {
                    @Override
                    public void onErrorResponse(VolleyError error) {
                        //displaying the error in toast if occurrs
                        Toast.makeText(getActivity(), error.getMessage(), Toast.LENGTH_SHORT).show();
                    }
                });

        // request queue
        AppController.getInstance().addToRequestQueue(movieReq);
    }
    private void updateCase(final String decision_date, final String case_outcome,final String mode_determination,
                            final String case_decision) {
        // Tag used to cancel the request
        String tag_string_req = "req_register";

        pDialog.setMessage((getResources().getString(R.string.case_updating)));
        showDialog();

        StringRequest strReq = new StringRequest(Request.Method.POST,
                AppConfig.URL_UPDATE_CASE, new Response.Listener<String>() {

            @Override
            public void onResponse(String response) {
                Log.d(TAG, "Case Register Response: " + response);
                hideDialog();

                try {
                    JSONObject jObj = new JSONObject(response);
                    boolean error = jObj.getBoolean("error");
                    if (!error) {
                        // User successfully stored in MySQL comment
                        // Now store the user in sqlite comment

//                        JSONObject user = jObj.getJSONObject("case");
//                        String filing_date = user.getString("filing_date");
//                        String case_year = user.getString("case_year");
//
//                        // Inserting row in users table comment
//                        db.addcase(filing_date, case_year);

                        Toast.makeText(getActivity(), (getResources().getString(R.string.case_updated)), Toast.LENGTH_LONG).show();

                        // Launch login activity
//                        Intent intent = new Intent(getActivity(), MainActivity.class);
//                        startActivity(intent);

                        UpdateFragment fragment = new UpdateFragment();
                        FragmentManager fragmentManager = getFragmentManager();
                        FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();
                        fragmentTransaction.replace(R.id.nav_host_fragment, fragment, fragment.getTag());
                        fragmentTransaction.commit();


                    } else {

                        // Error occurred in registration. Get the error
                        // message
                        String errorMsg = jObj.getString("error_msg");
                        Toast.makeText(getActivity(),
                                errorMsg, Toast.LENGTH_LONG).show();
                    }
                } catch (JSONException e) {
                    e.printStackTrace();
                }

            }
        }, new Response.ErrorListener() {

            @Override
            public void onErrorResponse(VolleyError error) {

                Toast.makeText(getActivity(),
                        (getResources().getString(R.string.no_network)), Toast.LENGTH_LONG).show();
                hideDialog();
            }
        }) {



            @Override
            protected Map<String, String> getParams() {

                // Posting params to register url
                Map<String, String> params = new HashMap<>();
                DecisionFragment.pendingCase=new PendingCase();
                HashMap<String, String> user = db.getUserDetails();


                params.put("case_number", getArguments().getString("case_number"));
                params.put("case_year",  getArguments().getString("case_year"));
                params.put("case_type",  getArguments().getString("case_type"));
                params.put("courtID",user.get("courtID"));
                params.put("decided_date", decision_date);
                params.put("mode_determination", mode_determination);
                params.put("case_outcome", case_outcome);
                params.put("decision_remarks", case_decision);


                return params;

            }

        };

        // Adding request to request queue
        AppController.getInstance().addToRequestQueue(strReq, tag_string_req);
    }
    private void updateLabel() {
        String myFormat = "dd-MM-YYY"; //In which you need put here
        SimpleDateFormat sdf = new SimpleDateFormat(myFormat, Locale.ENGLISH);

        DecisionDate.setText(sdf.format(myCalendar.getTime()));
    }
    private void showDialog() {
        if (!pDialog.isShowing())
            pDialog.show();
    }
    private void hideDialog() {
        if (pDialog.isShowing())
            pDialog.dismiss();
    }
}
