package com.example.primarycourt.activity.ui.update;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentPagerAdapter;
import androidx.viewpager.widget.ViewPager;

import com.example.primarycourt.R;
import com.example.primarycourt.helper.PendingCase;
import com.example.primarycourt.helper.SQLiteHandler;
import com.example.primarycourt.helper.SessionManager;
import com.google.android.material.tabs.TabLayout;

import java.util.ArrayList;
import java.util.List;

public class FinalFragment extends Fragment {
  public static PendingCase pendingCase;
  ViewPager viewPager;
  TabLayout tabLayout;
  public String accessID;
  private SQLiteHandler db;
  private SessionManager session;
  public FinalFragment() {
    // Required empty public constructor
  }

  public View onCreateView(LayoutInflater inflater, ViewGroup container,
                           Bundle savedInstanceState) {


    // Inflate the layout for this fragment
    View view = inflater.inflate(R.layout.fragment_final, container, false);

    viewPager = view.findViewById(R.id.viewpager);
    setupViewPager(viewPager);

    tabLayout = view.findViewById(R.id.tabs);
    tabLayout.setupWithViewPager(viewPager);






    return view;
  }



  private void setupViewPager(ViewPager viewPager) {


    ViewPagerAdapter adapter = new ViewPagerAdapter(getFragmentManager());
    adapter.addFragment(new AdjournedFragment() , "FOR ASSIGNMENT");
    adapter.addFragment(new UpdateFragment() , "FOR DECISION");
    viewPager.setAdapter(adapter);

  }

  class ViewPagerAdapter extends FragmentPagerAdapter {
    private final List<Fragment> mFragmentList = new ArrayList<>();
    private final List<String> mFragmentTitleList = new ArrayList<>();

    public ViewPagerAdapter(FragmentManager manager) {
      super(manager);
    }

    @Override
    public Fragment getItem(int position) {
      return mFragmentList.get(position);
    }

    @Override
    public int getCount() {
      return mFragmentList.size();
    }

    public void addFragment(Fragment fragment, String title) {
      mFragmentList.add(fragment);
      mFragmentTitleList.add(title);
    }

    @Override
    public CharSequence getPageTitle(int position) {
      return mFragmentTitleList.get(position);
    }
  }

}
