package com.example.primarycourt.activity.ui.update;

import android.app.ProgressDialog;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;

import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;

import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.VolleyLog;
import com.android.volley.toolbox.JsonArrayRequest;
import com.example.primarycourt.R;
import com.example.primarycourt.app.AppController;
import com.example.primarycourt.helper.CustomListAdapter;
import com.example.primarycourt.helper.PendingCase;
import com.example.primarycourt.helper.SQLiteHandler;
import com.example.primarycourt.helper.SessionManager;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import static android.content.ContentValues.TAG;
import static com.example.primarycourt.app.AppConfig.IP_PATH;

public class UpdateFragment extends Fragment {

    private ProgressDialog pDialog;
    private List<PendingCase> caseList = new ArrayList<PendingCase>();
    private ListView listView;
    private CustomListAdapter adapter;
    public static String courtID;
    public static int accessID, designation_id;
    public static String assigned_to;
    public String case_type;
    public String case_number;
    public String case_year;
    public String filing_date;
    public static String URL_PENDING_CASE;
    private SQLiteHandler db;
    TextView empty;
    EditText inputSearch_update;
    private SessionManager session;



    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View view = inflater.inflate(R.layout.fragment_update , container , false);


        listView = view.findViewById(R.id.list);
        empty = view.findViewById(android.R.id.empty);

        inputSearch_update = view.findViewById(R.id.inputSearch_update);
        adapter = new CustomListAdapter(getActivity() , caseList);
        listView.setEmptyView(empty);
        listView.setAdapter(adapter);

        pDialog = new ProgressDialog(getActivity());
        // Showing progress dialog before making http request
        pDialog.setMessage("Loading...");
        pDialog.show();

        // SQLite database handler


        db = new SQLiteHandler(getActivity());
        HashMap<String, String> user = db.getUserDetails();

        courtID = user.get("courtID");
        accessID = Integer.parseInt(user.get("accessID"));
        assigned_to = user.get("uid");
        designation_id = Integer.parseInt(user.get("designation_id"));

        //===============================================================================================
        //======================= VIew to  magistrate Incharge and RMAs =================================
        //===============================================================================================

      if(designation_id == 10){


          URL_PENDING_CASE = IP_PATH + "magistrate_get_pending_case.php?courtID=" + courtID + "&assigned_to=" + assigned_to;

        // Creating volley request obj
        JsonArrayRequest movieReq = new JsonArrayRequest(URL_PENDING_CASE ,
                new Response.Listener<JSONArray>() {
                    @Override
                    public void onResponse(JSONArray response) {
                        Log.d(TAG , response.toString());
                        hidePDialog();


                        // Parsing json
                        for (int i = 0; i < response.length(); i++) {
                            try {

                                JSONObject obj = response.getJSONObject(i);
                                PendingCase pending_list = new PendingCase();
                                pending_list.setCaseID(obj.getString("caseID"));
                                pending_list.setCaseType(obj.getString("case_type"));
                                pending_list.setThumbnailUrl(obj.getString("img"));
                                pending_list.setCaseNumber((obj.getString("case_number")));
                                pending_list.setCaseYear(obj.getString("case_year"));
                                pending_list.setAppellant((obj.getString("case_appellant")));
                                pending_list.setDefendant(obj.getString("case_defendant"));
                                pending_list.setClaim(obj.getString("case_claim"));
                                pending_list.setFilingDate(obj.getString("filing_date"));
                                pending_list.setMagistrate(obj.getString("assigned_to"));

                                pending_list.setAppellantPosition(obj.getString("appellant_position"));
                                pending_list.setAppellantAge((obj.getString("appellant_age")));
                                pending_list.setAppellantGender(obj.getString("appellant_gender"));
                                pending_list.setAppellantPhone((obj.getString("appellant_phone")));
                                pending_list.setDefendantPosition(obj.getString("defendant_position"));
                                pending_list.setDefendantAge(obj.getString("defendant_age"));
                                pending_list.setDefendantGender(obj.getString("defendant_gender"));
                                pending_list.setDefendantPhone(obj.getString("defendant_phone"));


                                caseList.add(pending_list);


                                listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {

                                    public void onItemClick(AdapterView<?> l , View view , int position , long id) {
                                        //Put the value
                                        String CaseType = ((TextView) view.findViewById(R.id.case_type)).getText().toString();
                                        String CaseNumber = ((TextView) view.findViewById(R.id.case_number)).getText().toString();
                                        String CaseYear = ((TextView) view.findViewById(R.id.case_year)).getText().toString();
                                        String CaseAppellant = ((TextView) view.findViewById(R.id.appellant)).getText().toString();
                                        String CaseDefendant = ((TextView) view.findViewById(R.id.defendant)).getText().toString();
                                        String CaseClaim = ((TextView) view.findViewById(R.id.case_claim)).getText().toString();
                                        String CaseID = ((TextView) view.findViewById(R.id.caseID)).getText().toString();
                                        String CaseFilingDate = ((TextView) view.findViewById(R.id.case_filing_date)).getText().toString();
                                        String CaseAssignment = ((TextView) view.findViewById(R.id.magistrate)).getText().toString();

                                        String AppellantPosition = ((TextView) view.findViewById(R.id.AppellantPosition)).getText().toString();
                                        String AppellantAge = ((TextView) view.findViewById(R.id.AppellantAge)).getText().toString();
                                        String AppellantGender = ((TextView) view.findViewById(R.id.AppellantGender)).getText().toString();
                                        String AppellantPhone = ((TextView) view.findViewById(R.id.AppellantPhone)).getText().toString();
                                        String DefendantPosition = ((TextView) view.findViewById(R.id.DefendantPosition)).getText().toString();
                                        String DefendantAge = ((TextView) view.findViewById(R.id.DefendantAge)).getText().toString();
                                        String DefendantGender = ((TextView) view.findViewById(R.id.DefendantGender)).getText().toString();
                                        String DefendantPhone = ((TextView) view.findViewById(R.id.DefendantPhone)).getText().toString();


                                        Bundle bundle = new Bundle();
                                        bundle.putString("caseID" , CaseID);
                                        bundle.putString("case_type" , CaseType);
                                        bundle.putString("case_number" , CaseNumber);
                                        bundle.putString("case_year" , CaseYear);
                                        bundle.putString("case_appellant" , CaseAppellant);
                                        bundle.putString("case_defendant" , CaseDefendant);
                                        bundle.putString("case_claim" , CaseClaim);
                                        bundle.putString("filing_date" , CaseFilingDate);
                                        bundle.putString("assigned_to" , CaseAssignment);
                                        bundle.putString("appellant_position" , AppellantPosition);
                                        bundle.putString("appellant_age" , AppellantAge);
                                        bundle.putString("appellant_gender" , AppellantGender);
                                        bundle.putString("appellant_phone" , AppellantPhone);
                                        bundle.putString("defendant_position" , DefendantPosition);
                                        bundle.putString("defendant_age" , DefendantAge);
                                        bundle.putString("defendant_gender" , DefendantGender);
                                        bundle.putString("defendant_phone" , DefendantPhone);


                                        DecisionFragment fragment = new DecisionFragment();
//                                        FinalFragment fragment = new FinalFragment();
                                        FragmentManager fragmentManager = getFragmentManager();
                                        FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();
                                        fragment.setArguments(bundle);
                                        fragmentTransaction.replace(R.id.nav_host_fragment , fragment , fragment.getTag());
                                        fragmentTransaction.addToBackStack(null);
                                        fragmentTransaction.commit();


                                    }
                                });

                            } catch (JSONException e) {
                                e.printStackTrace();
                            }

                        }

                        // notifying list adapter about data changes
                        // so that it renders the list view with updated data
                        adapter.notifyDataSetChanged();


                    }
                } , new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                VolleyLog.d(TAG , "Error: " + error.getMessage());
                hidePDialog();

            }
        });

                // Adding request to request queue
                AppController.getInstance().addToRequestQueue(movieReq);
    }


    //===============================================================================================
    //======================= VIew to  magistrate Only ==============================================
    //===============================================================================================
    else{

          URL_PENDING_CASE = IP_PATH + "get_pending_case.php?courtID=" + courtID + "&assigned_to=" + assigned_to;

                // Creating volley request obj
                JsonArrayRequest movieReq = new JsonArrayRequest(URL_PENDING_CASE ,
                        new Response.Listener<JSONArray>() {
                            @Override
                            public void onResponse(JSONArray response) {
                                Log.d(TAG , response.toString());
                                hidePDialog();


                                // Parsing json
                                for (int i = 0; i < response.length(); i++) {
                                    try {

                                        JSONObject obj = response.getJSONObject(i);
                                        PendingCase pending_list = new PendingCase();
                                        pending_list.setCaseID(obj.getString("caseID"));
                                        pending_list.setCaseType(obj.getString("case_type"));
                                        pending_list.setThumbnailUrl(obj.getString("img"));
                                        pending_list.setCaseNumber((obj.getString("case_number")));
                                        pending_list.setCaseYear(obj.getString("case_year"));
                                        pending_list.setAppellant((obj.getString("case_appellant")));
                                        pending_list.setDefendant(obj.getString("case_defendant"));
                                        pending_list.setClaim(obj.getString("case_claim"));
                                        pending_list.setFilingDate(obj.getString("filing_date"));
                                        pending_list.setMagistrate(obj.getString("assigned_to"));

                                        pending_list.setAppellantPosition(obj.getString("appellant_position"));
                                        pending_list.setAppellantAge((obj.getString("appellant_age")));
                                        pending_list.setAppellantGender(obj.getString("appellant_gender"));
                                        pending_list.setAppellantPhone((obj.getString("appellant_phone")));
                                        pending_list.setDefendantPosition(obj.getString("defendant_position"));
                                        pending_list.setDefendantAge(obj.getString("defendant_age"));
                                        pending_list.setDefendantGender(obj.getString("defendant_gender"));
                                        pending_list.setDefendantPhone(obj.getString("defendant_phone"));

                                        caseList.add(pending_list);


                                        listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {

                                            public void onItemClick(AdapterView<?> l , View view , int position , long id) {
                                                //Put the value
                                                String CaseType = ((TextView) view.findViewById(R.id.case_type)).getText().toString();
                                                String CaseNumber = ((TextView) view.findViewById(R.id.case_number)).getText().toString();
                                                String CaseYear = ((TextView) view.findViewById(R.id.case_year)).getText().toString();
                                                String CaseAppellant = ((TextView) view.findViewById(R.id.appellant)).getText().toString();
                                                String CaseDefendant = ((TextView) view.findViewById(R.id.defendant)).getText().toString();
                                                String CaseClaim = ((TextView) view.findViewById(R.id.case_claim)).getText().toString();
                                                String CaseID = ((TextView) view.findViewById(R.id.caseID)).getText().toString();
                                                String CaseFilingDate = ((TextView) view.findViewById(R.id.case_filing_date)).getText().toString();
                                                String CaseAssignment = ((TextView) view.findViewById(R.id.magistrate)).getText().toString();

                                                String AppellantPosition = ((TextView) view.findViewById(R.id.AppellantPosition)).getText().toString();
                                                String AppellantAge = ((TextView) view.findViewById(R.id.AppellantAge)).getText().toString();
                                                String AppellantGender = ((TextView) view.findViewById(R.id.AppellantGender)).getText().toString();
                                                String AppellantPhone = ((TextView) view.findViewById(R.id.AppellantPhone)).getText().toString();
                                                String DefendantPosition = ((TextView) view.findViewById(R.id.DefendantPosition)).getText().toString();
                                                String DefendantAge = ((TextView) view.findViewById(R.id.DefendantAge)).getText().toString();
                                                String DefendantGender = ((TextView) view.findViewById(R.id.DefendantGender)).getText().toString();
                                                String DefendantPhone = ((TextView) view.findViewById(R.id.DefendantPhone)).getText().toString();

                                                Bundle bundle = new Bundle();
                                                bundle.putString("caseID" , CaseID);
                                                bundle.putString("case_type" , CaseType);
                                                bundle.putString("case_number" , CaseNumber);
                                                bundle.putString("case_year" , CaseYear);
                                                bundle.putString("case_appellant" , CaseAppellant);
                                                bundle.putString("case_defendant" , CaseDefendant);
                                                bundle.putString("case_claim" , CaseClaim);
                                                bundle.putString("filing_date" , CaseFilingDate);
                                                bundle.putString("assigned_to" , CaseAssignment);
                                                bundle.putString("appellant_position" , AppellantPosition);
                                                bundle.putString("appellant_age" , AppellantAge);
                                                bundle.putString("appellant_gender" , AppellantGender);
                                                bundle.putString("appellant_phone" , AppellantPhone);
                                                bundle.putString("defendant_position" , DefendantPosition);
                                                bundle.putString("defendant_age" , DefendantAge);
                                                bundle.putString("defendant_gender" , DefendantGender);
                                                bundle.putString("defendant_phone" , DefendantPhone);


                                                DecisionFragment fragment = new DecisionFragment();
//                                        FinalFragment fragment = new FinalFragment();
                                                FragmentManager fragmentManager = getFragmentManager();
                                                FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();
                                                fragment.setArguments(bundle);

                                                fragmentTransaction.replace(R.id.nav_host_fragment , fragment , fragment.getTag());
                                                fragmentTransaction.commit();


                                            }
                                        });

                                    } catch (JSONException e) {
                                        e.printStackTrace();
                                    }

                                }

                                // notifying list adapter about data changes
                                // so that it renders the list view with updated data
                                adapter.notifyDataSetChanged();


                            }
                        } , new Response.ErrorListener() {
                    @Override
                    public void onErrorResponse(VolleyError error) {
                        VolleyLog.d(TAG , "Error: " + error.getMessage());
                        hidePDialog();

                    }
                });
                // Adding request to request queue
                AppController.getInstance().addToRequestQueue(movieReq);
    }




        /**
         * Enabling Search Filter
         * */
        inputSearch_update.addTextChangedListener(new TextWatcher() {

            @Override
            public void beforeTextChanged(CharSequence arg0, int arg1, int arg2, int arg3) {
                // TODO Auto-generated method stub
            }

            @Override
            public void onTextChanged(CharSequence cs, int arg1, int arg2, int arg3) {
                // When user changed the Text
                UpdateFragment.this.adapter.getFilter().filter(cs);

            }


            @Override
            public void afterTextChanged(Editable cs) {
                // TODO Auto-generated method stub
                inputSearch_update.removeTextChangedListener(this);
                inputSearch_update.addTextChangedListener(this);

                Log.e("Value","After");



            }
        });
        return view;
    }


    @Override
    public void onDestroy() {
        super.onDestroy();
        hidePDialog();
    }

    private void hidePDialog() {
        if (pDialog != null) {
            pDialog.dismiss();
            pDialog = null;
        }

    }




    


}